{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}

unit PGPComp;							// Version 1.3.2

{------------------------------------------------------------------------------}
{                                                                              }
{                This unit was generated on 30.09.99 19:40:45 by               }
{                     the RTE Software Component Generator.                    }
{                                                                              }
{                                                                              }
{               This code was written by : Michael in der Wiesche              }
{                                                                              }
{                     This code is copyright: 1999/2000 by                     }
{                            Michael in der Wiesche                            }
{                                                                              }
{------------------------------------------------------------------------------}

interface

uses
  Windows, SysUtils, Classes, Forms, ExtCtrls, StdCtrls, PGPErrorCodes, SPGP;

// Register --------------------------------------------------------------------

procedure Register;

// Global constants ------------------------------------------------------------

const
  SPGPVersion: Function: Longint = SPGP.Version;

  CompatibilityMode: Boolean = false;

  GeneratingKeys: Boolean = false;

  IsTrue = '1';

  PGPAnalyze_Min = SPGP.PGPAnalyze_Encrypted;

  PGPAnalyze_Encrypted = SPGP.PGPAnalyze_Encrypted;
  PGPAnalyze_Signed = SPGP.PGPAnalyze_Signed;
  PGPAnalyze_DetachedSignature = SPGP.PGPAnalyze_DetachedSignature;
  PGPAnalyze_Key = SPGP.PGPAnalyze_Key;
  PGPAnalyze_Unknown = SPGP.PGPAnalyze_Unknown;
  PGPAnalyze_EncryptedConventional = SPGP.PGPAnalyze_EncryptedConventional;
  PGPAnalyze_EncryptedNoKeys = SPGP.PGPAnalyze_EncryptedNoKeys;

  PGPAnalyze_Max = SPGP.PGPAnalyze_EncryptedNoKeys;

// Common types ----------------------------------------------------------------

type
  TMinPassLen = 1..255;
  TMinPassQual = 1..100;

  TKeyPropsFlag = Longint;

  TKeyType = (PGPPublic, PGPPrivate);

  TKeySize = (
    PGPKeySize_512,
    PGPKeySize_1024,
    PGPKeySize_2048
    );

  TSubKeySize = (
    PGPSubKeySize_512,
    PGPSubKeySize_1024,
    PGPSubKeySize_2048,
    PGPSubKeySize_4096
    );

  TKeyKind = (
    PGPPublicKey_Invalid,
    PGPPublicKey_RSA,
    PGPPublicKey_RSAEncryptOnly,
    PGPPublicKey_RSASignOnly,
    PGPPublicKey_DH,
    PGPPublicKey_DSA,
    PGPPublicKey_DHDSS
    );

  TKeyAlg = (
    PGPPublicKeyAlgorithm_Invalid,
    PGPPublicKeyAlgorithm_RSA,
    PGPPublicKeyAlgorithm_RSAEncryptOnly,
    PGPPublicKeyAlgorithm_RSASignOnly,
    PGPPublicKeyAlgorithm_ElGamal,
    PGPPublicKeyAlgorithm_DSA
    );

  TSignAlg = (
    PGPHashAlgorithm_Default,
    PGPHashAlgorithm_MD5,
    PGPHashAlgorithm_SHA,
    PGPHashAlgorithm_RIPEMD160,
    PGPHashAlgorithm_SHADouble
    );

  TConventionalAlg = (
    PGPCipherAlgorithm_None,
    PGPCipherAlgorithm_IDEA,
    PGPCipherAlgorithm_3DES,
    PGPCipherAlgorithm_CAST5
    );

  TTrustLevel = (
    PGPKeyTrust_Undefined,
    PGPKeyTrust_Unknown,
    PGPKeyTrust_Never,
    NotDefined_XXX,
    NotDefined_YYY,
    PGPKeyTrust_Marginal,
    PGPKeyTrust_Complete,
    PGPKeyTrust_Ultimate
    );

  TValidityLevel = (
    PGPValidity_Unknown,
    PGPValidity_Invalid,
    PGPValidity_Marginal,
    PGPValidity_Complete
    );

  TSigStatus = (
    SIGNED_GOOD,
    SIGNED_NOT,
    SIGNED_BAD,
    SIGNED_NO_KEY
    );

  TPGPPref = (
    PGPPref_PublicKeyring,
    PGPPref_PrivateKeyring,
    PGPPref_RandomSeedFile,
    PGPPref_DefaultKeyID,
    PGPPref_GroupsFile
    );

  TPGPPrefs = Set of TPGPPref;

  TPrefsPage = (
    PrefsPage_GeneralPrefs,
    PrefsPage_KeyringPrefs,
    PrefsPage_EmailPrefs,
    PrefsPage_HotkeyPrefs,
    PrefsPage_KeyserverPrefs,
    PrefsPage_CAPrefs,
    PrefsPage_AdvancedPrefs
    );

  TKeyProp = (
    PGPKeyProp_HexID,
    PGPKeyProp_UserID,
    PGPKeyProp_Fingerprint,
    PGPKeyProp_CreaTimeStr,
    PGPKeyProp_ExpTimeStr,
    PGPKeyProp_Size,
    PGPKeyProp_Algorithm,
    PGPKeyProp_Trust,
    PGPKeyProp_Validity,
    PGPKeyProp_CreaTimeNum,
    PGPKeyProp_ExpTimeNum,
    PGPKeyProp_Secret,
    PGPKeyProp_ImplicitTrust,
    PGPKeyProp_Revoked,
    PGPKeyProp_Disabled,
    PGPKeyProp_Expired,
    PGPKeyProp_SecShared,
    PGPKeyProp_CanEncrypt,
    PGPKeyProp_CanDecrypt,
    PGPKeyProp_CanSign,
    PGPKeyProp_CanVerify,
    PGPKeyProp_HasRevoker,
    PGPKeyProp_HasADK,
    PGPKeyProp_HasSubKey
    );

  TKeyProps = Set of TKeyProp;

  TKeyRec = Record
    kType: TKeyType;
    kHexID: String;
    kUserID: String;
    kSize: String;
    kFingerprint: String;
    kTrust: TTrustLevel;
    kValidity: TValidityLevel;
    kAlgorithm: TKeyAlg;
    kCreaTimeStr: String;
    kCreaTimeNum: Longint;
    kExpTimeStr: String;
    kExpTimeNum: Longint;
    kImplicitTrust: Boolean;
    kRevoked: Boolean;
    kDisabled: Boolean;
    kExpired: Boolean;
    kSecShared: Boolean;
    kCanEncrypt: Boolean;
    kCanDecrypt: Boolean;
    kCanSign: Boolean;
    kCanVerify: Boolean;
    kHasRevoker: Boolean;
    kHasADK: Boolean;
    kHasSubKey: Boolean;
  end;

  TSigRec = Record
    sStatus: TSigStatus;
    sUserID: String;
    sHexID: String;
    sCreaTimeStr: String;
    sCreaTimeNum: Longint;
    sChecked: Boolean;
    sVerified: Boolean;
    sValidity: TValidityLevel;
    sRevoked: Boolean;
    sDisabled: Boolean;
    sExpired: Boolean;
  end;

  TPathArray = SPGP.TPathArray;
  TKeyHexIDArray = SPGP.TKeyHexIDArray;
  PPreferenceRec = SPGP.PPreferenceRec;
  TPreferenceRec = SPGP.TPreferenceRec;

// Common Procs ----------------------------------------------------------------

type
  TOnFailure = Procedure(ErrorCode: Longint; const ErrorMsg: String) of Object;
  TOnGetKeyID = Procedure(var KeyID: String) of Object;
  TOnGetKeyIDs = Procedure(const KeyIDs: TStringList) of Object;
  TOnGetSignKeyID = Procedure(var SignKeyID: String) of Object;
  TOnGetSignKeyPass = Procedure(const KeyProps: TKeyRec; var SignKeyPass: String) of Object;
  TOnWipePassphrase = Procedure(const Passphrase: String) of Object;

// Common components -----------------------------------------------------------

  // TFileIn

type
  TOnGetFileIn = Procedure(var FileIn: String) of Object;
  TFileIn = class(TComponent)
  private
    FFileIn: String;
    FOnFailure: TOnFailure;
    FOnGetFileIn: TOnGetFileIn;
  protected
  public
  published
    property FileIn: String
      read FFileIn
      write FFileIn;
    property OnFailure: TOnFailure
      read FOnFailure
      write FOnFailure;
    property OnGetFileIn: TOnGetFileIn
      read FOnGetFileIn
      write FOnGetFileIn;
  end;

  // TFileOut

  TOnGetFileOut = Procedure(var FileOut: String) of Object;
  TFileOut = class(TComponent)
  private
    FFileOut: String;
    FOnFailure: TOnFailure;
    FOnGetFileOut: TOnGetFileOut;
  protected
  public
  published
    property FileOut: String
      read FFileOut
      write FFileOut;
    property OnFailure: TOnFailure
      read FOnFailure
      write FOnFailure;
    property OnGetFileOut: TOnGetFileOut
      read FOnGetFileOut
      write FOnGetFileOut;
  end;

  // TFileInOut

type
  TFileInOut = class(TComponent)
  private
    FFileIn: String;
    FFileOut: String;
    FOnFailure: TOnFailure;
    FOnGetFileIn: TOnGetFileIn;
    FOnGetFileOut: TOnGetFileOut;
  protected
  public
  published
    property FileIn: String
      read FFileIn
      write FFileIn;
    property FileOut: String
      read FFileOut
      write FFileOut;
    property OnFailure: TOnFailure
      read FOnFailure
      write FOnFailure;
    property OnGetFileIn: TOnGetFileIn
      read FOnGetFileIn
      write FOnGetFileIn;
    property OnGetFileOut: TOnGetFileOut
      read FOnGetFileOut
      write FOnGetFileOut;
  end;

  // TSigFile

type
  TOnGetSigFile =  Procedure(var SigFile: String) of Object;
  TSigFile = class(TComponent)
  private
    FSigFile: String;
    FOnFailure: TOnFailure;
    FOnGetSigFile: TOnGetSigFile;
  protected
  public
  published
    property SigFile: String
      read FSigFile
      write FSigFile;
    property OnFailure: TOnFailure
      read FOnFailure
      write FOnFailure;
    property OnGetSigFile: TOnGetSigFile
      read FOnGetSigFile
      write FOnGetSigFile;
  end;

  // TSignKey

type
  TOnGetKeyHexID = Procedure(var KeyHexID: String) of Object;
  TOnGetSignHexID = Procedure(var SignHexID: String) of Object;
  TOnGetUserID = Procedure(var UserID: String) of Object;
  TSignKey = class(TComponent)
  private
    FKeyHexID: String;
    FSignHexID: String;
    FUserID: String;
    FOnFailure: TOnFailure;
    FOnGetKeyHexID: TOnGetKeyHexID;
    FOnGetSignHexID: TOnGetSignHexID;
    FOnGetUserID: TOnGetUserID;
    procedure SetKeyHexID(const Value: String);
    procedure SetSignHexID(const Value: String);
  protected
  public
  published
    property KeyHexID: String
      read FKeyHexID
      write SetKeyHexID;
    property SignHexID: String
      read FSignHexID
      write SetSignHexID;
    property UserID: String
      read FUserID
      write FUserID;
    property OnFailure: TOnFailure
      read FOnFailure
      write FOnFailure;
    property OnGetKeyHexID: TOnGetKeyHexID
      read FOnGetKeyHexID
      write FOnGetKeyHexID;
    property OnGetSignHexID: TOnGetSignHexID
      read FOnGetSignHexID
      write FOnGetSignHexID;
    property OnGetUserID: TOnGetUserID
      read FOnGetUserID
      write FOnGetUserID;
  end;

  // TIDLists

type
  TIDLists = class(TComponent)
    private
      FRingProps: TKeyProps;
      FComboBox: TComboBox;
      FListBox: TListBox;
      FHexIDList: TStringList;
      FUserIDList: TStringList;
      FRingPropsList: TStringList;
      FOnFailure: TOnFailure;
      function GetKeyKind(const rKeyProps: TKeyRec): TKeyKind;
    protected
      constructor Create(AOwner: TComponent); override;
      destructor Destroy; override;
      procedure Clear;
      procedure Add(const KeyPropsStr: String);
    public
      property HexIDList: TStringList
	read FHexIDList;
      property UserIDList: TStringList
	read FUserIDList;
      property RingPropsList: TStringList
	read FRingPropsList;
      function KeyType(const KeyHexID: String): TKeyType;
      function KeyKind(const KeyHexID: String): TKeyKind;
      function ExtractRingProps(const KeyHexID: String): TKeyRec;
    published
      property ComboBox: TComboBox
	read FComboBox
	write FComboBox;
      property ListBox: TListBox
	read FListBox
	write FListBox;
      property OnFailure: TOnFailure
	read FOnFailure
	write FOnFailure;
  end;

// TPGPGetKeyProps -------------------------------------------------------------

type
  TOnGetKeyProps = Procedure(const RingPropsList: TStringList) of Object;
  TOnGetKeyPropSig = Procedure(var KeySignatureHexIDs: String) of Object;
  TOnGetKeyPropUserID = Procedure(const KeyUserNameIDs: String) of Object;
  TOnGetKeyRingToFile = Procedure(const KeyRingPropsFile: String) of Object;
  TPGPGetKeyProps = class(TIDLists)
  private
    FFileOut: String;
    FKeyID: String;
    FUserID: String;
    FKeyProps: TKeyProps;
    FKeyPropsList: TStringList;
    FOnGetFileOut: TOnGetFileOut;
    FOnGetKeyID: TOnGetKeyID;
    FOnGetKeyProps: TOnGetKeyProps;
    FOnGetKeyPropSig: TOnGetKeyPropSig;
    FOnGetKeyPropUserID: TOnGetKeyPropUserID;
    FOnGetKeyRingToFile: TOnGetKeyRingToFile;
    FOnGetUserID: TOnGetUserID;
    procedure GetKeyLists(var KeyPropsStr: String);
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoGetKeyProps: Longint;
    function DoGetKeyPropSig: Longint;
    function DoGetKeyPropUserID: Longint;
    function DoGetKeyPropADK: Longint;
    function DoGetKeyPropRevokationKey: Longint;
    function DoGetKeyRingToFile: Longint;
    function KeyIsOnRing: Boolean;
    function KeyRingCount: Longint;
    procedure Update;
  published
    property FileOut: String
      read FFileOut
      write FFileOut;
    property KeyID: String
      read FKeyID
      write FKeyID;
    property UserID: String
      read FUserID
      write FUserID;
    property KeyProps: TKeyProps
      read FKeyProps
      write FKeyProps;
    property OnGetFileOut: TOnGetFileOut
      read FOnGetFileOut
      write FOnGetFileOut;
    property OnGetKeyID: TOnGetKeyID
      read FOnGetKeyID
      write FOnGetKeyID;
    property OnGetKeyProps: TOnGetKeyProps
      read FOnGetKeyProps
      write FOnGetKeyProps;
    property OnGetKeyPropSig: TOnGetKeyPropSig
      read FOnGetKeyPropSig
      write FOnGetKeyPropSig;
    property OnGetKeyPropUserID: TOnGetKeyPropUserID
      read FOnGetKeyPropUserID
      write FOnGetKeyPropUserID;
    property OnGetKeyRingToFile: TOnGetKeyRingToFile
      read FOnGetKeyRingToFile
      write FOnGetKeyRingToFile;
    property OnGetUserID: TOnGetUserID
      read FOnGetUserID
      write FOnGetUserID;
  end;

// TPGPSetKeyProps -------------------------------------------------------------

type
  TOnGetPass = Procedure(const KeyProps: TKeyRec; MinPassLen, MinPassQual: Longint;
  			 var OldPassphrase, NewPassphrase: String) of Object;
  TPGPSetKeyProps = class(TComponent)
  private
    FGetKeyProps: TPGPGetKeyProps;
    FKeyID: String;
    FMinPassLen: TMinPassLen;
    FMinPassQual: TMinPassQual;
    FStandardDlg: Boolean;
    FParentHandle: HWND;
    FOnFailure: TOnFailure;
    FOnGetKeyID: TOnGetKeyID;
    FOnGetPass: TOnGetPass;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoKeyDisable: Longint;
    function DoKeyEnable: Longint;
    function DoKeyRemove: Longint;
    function DoKeyPassChange: Longint;
    property ParentHandle: HWND
      read FParentHandle
      write FParentHandle;
  published
    property GetKeyProps: TPGPGetKeyProps
      read FGetKeyProps
      write FGetKeyProps;
    property KeyID: String
      read FKeyID
      write FKeyID;
    property MinPassLen: TMinPassLen
      read FMinPassLen
      write FMinPassLen;
    property MinPassQual: TMinPassQual
      read FMinPassQual
      write FMinPassQual;
    property StandardDlg: Boolean
      read FStandardDlg
      write FStandardDlg;
    property OnFailure: TOnFailure
      read FOnFailure
      write FOnFailure;
    property OnGetKeyID: TOnGetKeyID
      read FOnGetKeyID
      write FOnGetKeyID;
    property OnGetPass: TOnGetPass
      read FOnGetPass
      write FOnGetPass;
  end;

// TPGPKeySign -----------------------------------------------------------------

type
  TOnKeySigned = Procedure(const SigHexIDs: String) of Object;
  TPGPKeySign = class(TSignKey)
  private
    FExpires: Longint;
    FExportable: Boolean;
    FSignKeyPass: String;
    FTrust: TTrustLevel;
    FValidity: TValidityLevel;
    FOnGetSignKeyPass: TOnGetSignKeyPass;
    FOnKeySigned: TOnKeySigned;
    FOnWipePassphrase: TOnWipePassphrase;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoKeySign: Longint;
  published
    property Expires: Longint
      read FExpires
      write FExpires;
    property Exportable: Boolean
      read FExportable
      write FExportable;
    {property Trust: TTrustLevel			// not implemented
      read FTrust
      write FTrust;}
    {property Validity: TValidityLevel			// not implemented
      read FValidity
      write FValidity;}
    property OnGetSignKeyPass: TOnGetSignKeyPass
      read FOnGetSignKeyPass
      write FOnGetSignKeyPass;
    property OnKeySigned: TOnKeySigned
      read FOnKeySigned
      write FOnKeySigned;
    property OnWipePassphrase: TOnWipePassphrase
      read FOnWipePassphrase
      write FOnWipePassphrase;
  end;

// TPGPKeySigRemove ------------------------------------------------------------

type
  TOnKeySigRemoved = Procedure(const SigHexIDs: String) of Object;
  TPGPKeySigRemove = class(TSignKey)
  private
    FOnKeySigRemoved: TOnKeySigRemoved;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoKeySigRemove: Longint;
  published
    property OnKeySigRemoved: TOnKeySigRemoved
      read FOnKeySigRemoved
      write FOnKeySigRemoved;
  end;

// TPGPKeyImport ---------------------------------------------------------------

type
  TOnKeyImported = Procedure(const RingPropsList: TStringList; KeysImported: Longint) of Object;
  TPGPKeyImport = class(TFileIn)
  private
    FGetKeyProps: TPGPGetKeyProps;
    FImport: Boolean;
    FKeyPropsList: TStringList;
    FOnKeyImported: TOnKeyImported;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoKeyImport(const BufferIn: String): Longint;
    function DoKeyImportFile: Longint;
  published
    property GetKeyProps: TPGPGetKeyProps
      read FGetKeyProps
      write FGetKeyProps;
    property Import: Boolean
      read FImport
      write FImport;
    property OnKeyImported: TOnKeyImported
      read FOnKeyImported
      write FOnKeyImported;
  end;

// TPGPKeyExport ---------------------------------------------------------------

type
  TOnKeyExported = Procedure(const Keys: String; const FileOut: String) of Object;
  TPGPKeyExport = class(TFileOut)
  private
    FExpCompatible: Boolean;
    FExpPrivate: Boolean;
    FKeyIDs: TStringList;
    FOnGetKeyIDs: TOnGetKeyIDs;
    FOnKeyExported: TOnKeyExported;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoKeyExport: Longint;
    function DoKeyExportFile: Longint;
  published
    property ExpCompatible: Boolean
      read FExpCompatible
      write FExpCompatible;
    property ExpPrivate: Boolean
      read FExpPrivate
      write FExpPrivate;
    property KeyIDs: TStringList
      read FKeyIDs
      write FKeyIDs;
    property OnGetKeyIDs: TOnGetKeyIDs
      read FOnGetKeyIDs
      write FOnGetKeyIDs;
    property OnKeyExported: TOnKeyExported
      read FOnKeyExported
      write FOnKeyExported;
  end;

// TPGPDetachedSigCreate -------------------------------------------------------

type
  TOnSigCreated = Procedure(const SigFile: String) of Object;
  TPGPDetachedSigCreate = class(TSigFile)
  private
    FArmor: Boolean;
    FComment: String;
    FFileIn: String;
    FSignAlg: TSignAlg;
    FSignKeyID: String;
    FSignKeyPass: String;
    FStandardDlg: Boolean;
    FParentHandle: HWND;
    FOnGetFileIn: TOnGetFileIn;
    FOnGetSignKeyID: TOnGetSignKeyID;
    FOnGetSignKeyPass: TOnGetSignKeyPass;
    FOnSigCreated: TOnSigCreated;
    FOnWipePassphrase: TOnWipePassphrase;
    procedure SetComment(const Value: String);
    function GetSigningPass: Boolean;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoSigCreate: Longint;
    property ParentHandle: HWND
      read FParentHandle
      write FParentHandle;
  published
    property Armor: Boolean
      read FArmor
      write FArmor;
    property Comment: String
      read FComment
      write SetComment;
    property FileIn: String
      read FFileIn
      write FFileIn;
    property SignAlg: TSignAlg
      read FSignAlg
      write FSignAlg;
    property SignKeyID: String
      read FSignKeyID
      write FSignKeyID;
    property StandardDlg: Boolean
      read FStandardDlg
      write FStandardDlg;
    property OnGetFileIn: TOnGetFileIn
      read FOnGetFileIn
      write FOnGetFileIn;
    property OnGetSignKeyID: TOnGetSignKeyID
      read FOnGetSignKeyID
      write FOnGetSignKeyID;
    property OnGetSignKeyPass: TOnGetSignKeyPass
      read FOnGetSignKeyPass
      write FOnGetSignKeyPass;
    property OnSigCreated: TOnSigCreated
      read FOnSigCreated
      write FOnSigCreated;
    property OnWipePassphrase: TOnWipePassphrase
      read FOnWipePassphrase
      write FOnWipePassphrase;
  end;

// TPGPDetachedSigVerify -----------------------------------------------------

type
  TOnGetSignedFile = Procedure(var SignedFile: String) of Object;
  TOnSigVerified = Procedure(const SigProps: TSigRec) of Object;
  TPGPDetachedSigVerify = class(TSigFile)
  private
    FSignedFile: String;
    FOnGetSignedFile: TOnGetSignedFile;
    FOnSigVerified: TOnSigVerified;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoSigVerify: Longint;
  published
    property SignedFile: String
      read FSignedFile
      write FSignedFile;
    property OnGetSignedFile: TOnGetSignedFile
      read FOnGetSignedFile
      write FOnGetSignedFile;
    property OnSigVerified: TOnSigVerified
      read FOnSigVerified
      write FOnSigVerified;
  end;

// TPGPEncode ------------------------------------------------------------------

type
  TOnEncoded = Procedure(const BufferOut, FileOut: String) of Object;
  TOnGetConventionalPass = Procedure(var ConventionalPass: String) of Object;
  TOnGetCryptKeyIDs = Procedure(const CryptKeyIDs: TStringList) of Object;
  TPGPEncode = class(TFileInOut)
  private
    FArmor: Boolean;
    FClear: Boolean;
    FComment: String;
    FCompress: Boolean;
    FConventional: Boolean;
    FConventionalAlg: TConventionalAlg;
    FConventionalPass: String;
    FCryptKeyIDs: TStringList;
    FEncrypt: Boolean;
    FEyesOnly: Boolean;
    FMime: Boolean;
    FMimeSeparator: String;
    FSign: Boolean;
    FSignAlg: TSignAlg;
    FSignKeyID: String;
    FSignKeyPass: String;
    FTextmode: Boolean;
    FStandardDlg: Boolean;
    FParentHandle: HWND;
    FOnEncoded: TOnEncoded;
    FOnGetCryptKeyIDs: TOnGetCryptKeyIDs;
    FOnGetConventionalPass: TOnGetConventionalPass;
    FOnGetSignKeyID: TOnGetSignKeyID;
    FOnGetSignKeyPass: TOnGetSignKeyPass;
    FOnWipePassphrase: TOnWipePassphrase;
    procedure SetArmor(Value: Boolean);
    procedure SetClear(Value: Boolean);
    procedure SetComment(const Value: String);
    procedure SetCompress(Value: Boolean);
    procedure SetConventional(Value: Boolean);
    procedure SetEncrypt(Value: Boolean);
    procedure SetMime(Value: Boolean);
    procedure SetSign(Value: Boolean);
    function GetParams: Boolean;
    function Call_Encode(const BufferIn: String; var BufferOut: String): Longint;
    function Call_EncodeFile(const FileIn, FileOut: String): Longint;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoEncode(const BufferIn: String): Longint;
    function DoEncodeFile: Longint;
    property ParentHandle: HWND
      read FParentHandle
      write FParentHandle;
  published
    property Armor: Boolean
      read FArmor
      write SetArmor;
    property Clear: Boolean
      read FClear
      write SetClear;
    property Comment: String
      read FComment
      write SetComment;
    property Compress: Boolean
      read FCompress
      write SetCompress;
    property Conventional: Boolean
      read FConventional
      write SetConventional;
    property ConventionalAlg: TConventionalAlg
      read FConventionalAlg
      write FConventionalAlg;
    property CryptKeyIDs: TStringList
      read FCryptKeyIDs
      write FCryptKeyIDs;
    property Encrypt: Boolean
      read FEncrypt
      write SetEncrypt;
    property EyesOnly: Boolean
      read FEyesOnly
      write FEyesOnly;
    property Mime: Boolean
      read FMime
      write SetMime;
    property MimeSeparator: String
      read FMimeSeparator;
    property Sign: Boolean
      read FSign
      write SetSign;
    property SignAlg: TSignAlg
      read FSignAlg
      write FSignAlg;
    property SignKeyID: String
      read FSignKeyID
      write FSignKeyID;
    property Textmode: Boolean
      read FTextmode
      write FTextmode;
    property StandardDlg: Boolean
      read FStandardDlg
      write FStandardDlg;
    property OnEncoded: TOnEncoded
      read FOnEncoded
      write FOnEncoded;
    property OnGetCryptKeyIDs: TOnGetCryptKeyIDs
      read FOnGetCryptKeyIDs
      write FOnGetCryptKeyIDs;
    property OnGetConventionalPass: TOnGetConventionalPass
      read FOnGetConventionalPass
      write FOnGetConventionalPass;
    property OnGetSignKeyID: TOnGetSignKeyID
      read FOnGetSignKeyID
      write FOnGetSignKeyID;
    property OnGetSignKeyPass: TOnGetSignKeyPass
      read FOnGetSignKeyPass
      write FOnGetSignKeyPass;
    property OnWipePassphrase: TOnWipePassphrase
      read FOnWipePassphrase
      write FOnWipePassphrase;
  end;

// TPGPDecode ------------------------------------------------------------------

type
  TOnDecoded = Procedure(const BufferOut, FileOut: String; const SigProps: TSigRec) of Object;
  TOnGetPassphrase = Procedure(const KeyProps: TKeyRec; var Passphrase: String) of Object;
  TPGPDecode = class(TFileInOut)
  private
    FPassphrase: String;
    FStandardDlg: Boolean;
    FParentHandle: HWND;
    FOnDecoded: TOnDecoded;
    FOnGetPassphrase: TOnGetPassphrase;
    FOnWipePassphrase: TOnWipePassphrase;
    function GetDecryptPassphrase(AnalysisRes: Longint; const Analysis: String): Boolean;
    function CallDecode(const BufferIn: String; var BufferOut, SigProps: String): Longint;
    function CallDecodeFile(const FileIn, FileOut: String; var SigProps: String): Longint;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoDecode(const BufferIn: String): Longint;
    function DoDecodeFile: Longint;
    property ParentHandle: HWND
      read FParentHandle
      write FParentHandle;
  published
    property StandardDlg: Boolean
      read FStandardDlg
      write FStandardDlg;
    property OnDecoded: TOnDecoded
      read FOnDecoded
      write FOnDecoded;
    property OnGetPassphrase: TOnGetPassphrase
      read FOnGetPassphrase
      write FOnGetPassphrase;
    property OnWipePassphrase: TOnWipePassphrase
      read FOnWipePassphrase
      write FOnWipePassphrase;
  end;

// TPGPAnalyze -----------------------------------------------------------------

type
  TAnalysis = Record
    KeysUnknown: Longint;
    KeysKnown: Longint;
    KnownIDs: String;
  end;
  TOnGetAnalysis = Procedure(const Analysis: String) of Object;
  TPGPAnalyze = class(TComponent)
  private
    FFileIn: String;
    FOnFailure: TOnFailure;
    FOnGetAnalysis: TOnGetAnalysis;
    FOnGetFileIn: TOnGetFileIn;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoAnalyze(const BufferIn: String): Longint;
    function DoAnalyzeFile: Longint;
  published
    property FileIn: String
      read FFileIn
      write FFileIn;
    property OnFailure: TOnFailure
      read FOnFailure
      write FOnFailure;
    property OnGetAnalysis: TOnGetAnalysis
      read FOnGetAnalysis
      write FOnGetAnalysis;
    property OnGetFileIn: TOnGetFileIn
      read FOnGetFileIn
      write FOnGetFileIn;
  end;

// TPGPPreferences -------------------------------------------------------------

type
  TPrefStrings = Record
    PublicKeyring: String;
    PrivateKeyring: String;
    RandomSeedFile: String;
    GroupsFile: String;
    DefaultKeyHexID: String;
  end;
  TOnGetFileName = Procedure(var FileName: String) of Object;
  TOnGetPreferences = Procedure(const PrefStrings: TPrefStrings) of Object;
  TOnSetPreferences = Procedure(var PrefStrings: TPrefStrings) of Object;
  TPGPPreferences = class(TComponent)
  private
    FGetKeyProps: TPGPGetKeyProps;
    FFileName: String;
    FKeyHexID: String;
    FParentHandle: HWND;
    FPGPPref: TPGPPref;
    FPGPPrefs: TPGPPrefs;
    FPrefsPage: TPrefsPage;
    FPrefStrings: TPrefStrings;
    FOnFailure: TOnFailure;
    FOnGetFileName: TOnGetFileName;
    FOnGetKeyHexID: TOnGetKeyHexID;
    FOnGetPreferences: TOnGetPreferences;
    FOnSetPreferences: TOnSetPreferences;
    function SetKey(const KeyIDArray: TKeyHexIDArray; const KeyID: String): Boolean;
    function SetPath(const PathArray: TPathArray; const Path: String): Boolean;
    function SetPrefs(const PrefsRec: TPreferenceRec): Boolean;
    function GetPrefs(const PrefsRec: TPreferenceRec): Boolean;
    function GetFlags: Longint;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  public
    function DoGetPreference: Longint;
    function DoSetPreference: Longint;
    function ShowPrefsDialog: Longint;
    function DoGetPreferences: Longint;
    function DoSetPreferences: Longint;
    property ParentHandle: HWND
      read FParentHandle
      write FParentHandle;
  published
    property GetKeyProps: TPGPGetKeyProps
      read FGetKeyProps
      write FGetKeyProps;
    property FileName: String
      read FFileName
      write FFileName;
    property KeyHexID: String
      read FKeyHexID
      write FKeyHexID;
    property PrefsPage: TPrefsPage
      read FPrefsPage
      write FPrefsPage;
    property PublicKeyring: String
      read FPrefStrings.PublicKeyring
      write FPrefStrings.PublicKeyring;
    property PrivateKeyring: String
      read FPrefStrings.PrivateKeyring
      write FPrefStrings.PrivateKeyring;
    property RandomSeedFile: String
      read FPrefStrings.RandomSeedFile
      write FPrefStrings.RandomSeedFile;
    property GroupsFile: String
      read FPrefStrings.GroupsFile
      write FPrefStrings.GroupsFile;
    property DefaultKeyHexID: String
      read FPrefStrings.DefaultKeyHexID
      write FPrefStrings.DefaultKeyHexID;
    property PGPPref: TPGPPref
      read FPGPPref
      write FPGPPref;
    property PGPPrefs: TPGPPrefs
      read FPGPPrefs
      write FPGPPrefs;
    property OnFailure: TOnFailure
      read FOnFailure
      write FOnFailure;
    property OnGetFileName: TOnGetFileName
      read FOnGetFileName
      write FOnGetFileName;
    property OnGetKeyHexID: TOnGetKeyHexID
      read FOnGetKeyHexID
      write FOnGetKeyHexID;
    property OnGetPreferences: TOnGetPreferences
      read FOnGetPreferences
      write FOnGetPreferences;
    property OnSetPreferences: TOnSetPreferences
      read FOnSetPreferences
      write FOnSetPreferences;
  end;

// TPGPKeysGenerate ------------------------------------------------------------

type
  TOnGetGenPassphrase = Procedure(MinPassLen, MinPassQual: Longint; var Passphrase: String) of Object;
  TOnGetMasterKeyHexID = Procedure(var MasterKeyHexID: String) of Object;
  TOnGetUserNameAddress = Procedure(var UserName, EmailAddress: String) of Object;
  TOnTermination = Procedure(const NewUserID, NewKeyHexID: String; MasterKeyOnly, Aborted: Boolean) of Object;
  TGenOption = (oKey, oSubKey, oKeyPair);
  TKeyGenerator = class(TThread)
  private
    FOwner: TComponent;
  protected
    constructor Create(AOwner: TComponent);
    destructor Destroy; override;
    procedure Execute; override;
  public
    FOnExecute: TNotifyEvent;
  end;
  TPGPKeysGenerate = class(TTimer)
  private
    FKeyGenerator: TKeyGenerator;
    FGenResult: Longint;
    FKeyAlg: TKeyAlg;
    FSize: Longint;
    FUser: String;
    FGetKeyProps: TPGPGetKeyProps;
    FCipherAlg: TConventionalAlg;
    FExpires: Longint;
    FFastGenerate: Boolean;
    FFailNoEntropy: Boolean;
    FMinPassLen: TMinPassLen;
    FMinPassQual: TMinPassQual;
    FPassphrase: String;
    FUserName: String;
    FEmailAddress: String;
    FMasterKeyHexID: String;
    FMasterKeyOnly: Boolean;
    FNewKeyHexID: String;
    FNewSubKeyHexID: String;
    FKeySize: TKeySize;
    FSubKeySize: TSubKeySize;
    FStandardDlg: Boolean;
    FParentHandle: HWND;
    FOnFailure: TOnFailure;
    FOnGetGenPassphrase: TOnGetGenPassphrase;
    FOnGetMasterKeyHexID: TOnGetMasterKeyHexID;
    FOnGetUserNameAddress: TOnGetUserNameAddress;
    FOnTermination: TOnTermination;
    FOnWipePassphrase: TOnWipePassphrase;
  protected
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetUserName(const Name: String);
    procedure SetEmailAddress(const Address: String);
    function GetUserID: String;
    function GetKeySize: Longint;
    function GetSubKeySize: Longint;
    function GetPassphrase: Boolean;
    procedure OnKeyPairExecute(Sender: TObject);
    procedure OnKeyPairTerminate(Sender: TObject);
    procedure OnSingleKeyExecute(Sender: TObject);
    procedure OnSingleKeyTerminate(Sender: TObject);
  public
    function DHDSSKeyGenerate: Longint;
    function DHSubKeyGenerate: Longint;
    function DSAKeyGenerate: Longint;
    function RSAKeyGenerate: Longint;
    property ParentHandle: HWND
      read FParentHandle
      write FParentHandle;
  published
    property GetKeyProps: TPGPGetKeyProps
      read FGetKeyProps
      write FGetKeyProps;
    property CipherAlg: TConventionalAlg
      read FCipherAlg
      write FCipherAlg;
    property Expires: Longint
      read FExpires
      write FExpires;
    property FastGenerate: Boolean
      read FFastGenerate
      write FFastGenerate;
    property FailNoEntropy: Boolean
      read FFailNoEntropy
      write FFailNoEntropy;
    property MinPassLen: TMinPassLen
      read FMinPassLen
      write FMinPassLen;
    property MinPassQual: TMinPassQual
      read FMinPassQual
      write FMinPassQual;
    property UserName: String
      read FUserName
      write SetUserName;
    property EmailAddress: String
      read FEmailAddress
      write SetEmailAddress;
    property MasterKeyHexID: String
      read FMasterKeyHexID
      write FMasterKeyHexID;
    property KeySize: TKeySize
      read FKeySize
      write FKeySize;
    property SubKeySize: TSubKeySize
      read FSubKeySize
      write FSubKeySize;
    property StandardDlg: Boolean
      read FStandardDlg
      write FStandardDlg;
    property OnFailure: TOnFailure
      read FOnFailure
      write FOnFailure;
    property OnGetGenPassphrase: TOnGetGenPassphrase
      read FOnGetGenPassphrase
      write FOnGetGenPassphrase;
    property OnGetMasterKeyHexID: TOnGetMasterKeyHexID
      read FOnGetMasterKeyHexID
      write FOnGetMasterKeyHexID;
    property OnGetUserNameAddress: TOnGetUserNameAddress
      read FOnGetUserNameAddress
      write FOnGetUserNameAddress;
    property OnTermination: TOnTermination
      read FOnTermination
      write FOnTermination;
    property OnWipePassphrase: TOnWipePassphrase
      read FOnWipePassphrase
      write FOnWipePassphrase;
  end;

// Utilities -------------------------------------------------------------------

type
  EFailException = class(Exception);
  EKeyPropsError = class(Exception);
  ESigPropsError = class(Exception);
  EHexFormatError = class(Exception);

function PGP6X: Boolean;
function TabExtract(var sProps: String): String;
function GetLine(var sLines: String): String;
function ExtractKeyProps(const sKeyProps: String; setKeyProps: TKeyProps): TKeyRec;
function GetKeyResult(const sKeyProps: String): TKeyRec;
function GetSigResult(const sSigProps: String): TSigRec;
procedure WipePassphrase(var Passphrase: String; const FOnWipePassphrase: TOnWipePassphrase);


implementation

// String constants

const
  AT = '@';
  LT = '<';
  GT = '>';
  TAB = #9;
  EMPTY = '';
  SPACE = ' ';
  COMMA = ',';
  SLASH = '/';
  BSLASH = '\';
  CRLF = #13#10;
  NoDecKeyErr = 'No decryption key';
  NoPrivateKeyErr = 'No private key';
  LowPassLenErr = 'Required passphrase length:';
  LowPassQualErr = 'Required passphrase quality:';
  HexFormError = ': Hex format required - you provided: ';
  PathLengthError = ': Path length must not exceed ';
  InvalidMasterKey = 'Invalid master key: ';
  IllegalUserName = 'Illegal user name: ';
  IllegalEmailAddress = 'Illegal email address: ';
  UnknownEncErr = 'Unknown Encrypt error';
  UnknownDecErr = 'Unknown Decrypt error';
  UnknownKeyImportErr = 'Unknown KeyImport error';
  UnknownKeyExportErr = 'Unknown KeyExport error';
  UnknownSigCreateErr = 'Unknown SigCreate error';
  UnknownSigVerifyErr = 'Unknown SigVerify error';
  UnknownKeySignErr = 'Unknown KeySign error';
  UnknownKeySigRemoveErr = 'Unknown KeySigRemove error';
  UnknownGetPropsErr = 'Unknown GetProps error';
  UnknownGetPropSigErr = 'Unknown GetPropSig error';
  UnknownGetPropUserIDErr = 'Unknown GetPropUserID error';
  UnknownGetPropADKErr = 'Unknown GetPropADK error';
  UnknownGetPropRevocationKeyErr = 'Unknown GetPropRevocationKey error';
  UnknownGetRingIDErr = 'Unknown GetRingID error';
  UnknownGetRingToFileErr = 'Unknown GetRingToFile error';
  UnknownKeyRingCountErr = 'Unknown KeyRingCount error';
  UnknownKeyIsOnRingErr = 'Unknown KeyIsOnRing error';
  UnknownKeyDisableErr =  'Unknown KeyDisable error';
  UnknownKeyEnableErr =  'Unknown KeyEnable error';
  UnknownKeyPassChangeErr =  'Unknown KeyPassChange error';
  UnknownKeyRemoveErr = 'Unknown KeyRemove error';
  UnknownAnalysisErr = 'Unknown Analysis error';
  UnknownPrefsErr = 'Unknown Preferences error';
  UnknownKeyGenErr = 'Unknown KeyGenerate error';
  UnknownSubKeyGenErr = 'Unknown SubKeyGenerate error';


// Utility Funcs ---------------------------------------------------------------

function LastPos(Find: Char; const Dest: String): Longint; assembler;
asm
  PUSH	EDI
  XOR	ECX,ECX
  OR	Dest,Dest
  JZ	@END
  MOV	EDI,Dest
  MOV	ECX,[EDI-04h]
  JECXZ	@END
  ADD	EDI,ECX
  DEC	EDI
  STD
  REPNZ	SCASB
  JNZ	@END
  INC	ECX
  @END:
  MOV	EAX,ECX
  POP	EDI
  CLD
end;

function ExtractStr(var Source: String; Pos, Len: Longint): String;
begin
  Result:=Copy(Source, Pos, Len);
  Delete(Source, Pos, Len);
end;

function CharExtract(var sText: String; cLimit: Char): String;
var iCharPos: Longint; sBuffer: String;
begin
  Result:=EMPTY;
  if sText<>EMPTY then begin
    iCharPos:=pos(cLimit, sText);
    if iCharPos<>0 then begin
      sBuffer:=ExtractStr(sText, 1, iCharPos);
      Result:=Copy(sBuffer, 1, pred(iCharPos));
    end
    else begin
      Result:=sText;
      sText:=EMPTY;
    end;
  end;
end;

function PGP6X: Boolean;
begin
  Result:=(APIVersion>=PGP60);
end;

function TabExtract(var sProps: String): String;
begin
  Result:=Trim(CharExtract(sProps, TAB));
end;

function GetLine(var sLines: String): String;
var iCRLFPos: Longint;
begin
  iCRLFPos:=pos(CRLF, sLines);
  if iCRLFPos<>0 then begin
    Result:=ExtractStr(sLines, 1, succ(iCRLFPos));
    Delete(Result, iCRLFPos, 1);
    Result[Length(Result)]:=TAB;
  end
  else begin
    Result:=sLines;
    sLines:=EMPTY;
  end;
end;

function GetKeyPropsSet(KeyPropsFlag: TKeyPropsFlag): TKeyProps;
var fPGP6X: Boolean;
begin
  Result:=[];
  fPGP6X:=PGP6X;
  if KeyPropsFlag and spgpKeyProp_KeyID<>0 then Include(Result, PGPKeyProp_HexID);
  if KeyPropsFlag and spgpKeyProp_UserID<>0 then  Include(Result, PGPKeyProp_UserID);
  if KeyPropsFlag and spgpKeyProp_Fingerprint<>0 then Include(Result, PGPKeyProp_Fingerprint);
  if KeyPropsFlag and spgpKeyProp_CreationTimeStr<>0 then Include(Result, PGPKeyProp_CreaTimeStr);
  if KeyPropsFlag and spgpKeyProp_ExpirationTimeStr<>0 then Include(Result, PGPKeyProp_ExpTimeStr);
  if KeyPropsFlag and spgpKeyProp_Keybits<>0 then Include(Result, PGPKeyProp_Size);
  if KeyPropsFlag and spgpKeyProp_KeyAlg<>0 then Include(Result, PGPKeyProp_Algorithm);
  if KeyPropsFlag and spgpKeyProp_Trust<>0 then Include(Result, PGPKeyProp_Trust);
  if KeyPropsFlag and spgpKeyProp_Validity<>0 then Include(Result, PGPKeyProp_Validity);
  if KeyPropsFlag and spgpKeyProp_CreationTime<>0 then Include(Result, PGPKeyProp_CreaTimeNum);
  if KeyPropsFlag and spgpKeyProp_ExpirationTime<>0 then Include(Result, PGPKeyProp_ExpTimeNum);
  if KeyPropsFlag and spgpKeyProp_IsSecret<>0 then Include(Result, PGPKeyProp_Secret);
  if KeyPropsFlag and spgpKeyProp_IsAxiomatic<>0 then Include(Result, PGPKeyProp_ImplicitTrust);
  if KeyPropsFlag and spgpKeyProp_IsRevoked<>0 then Include(Result, PGPKeyProp_Revoked);
  if KeyPropsFlag and spgpKeyProp_IsDisabled<>0 then Include(Result, PGPKeyProp_Disabled);
  if KeyPropsFlag and spgpKeyProp_IsExpired<>0 then Include(Result, PGPKeyProp_Expired);
  if fPGP6X and (KeyPropsFlag and spgpKeyProp_IsSecretShared<>0) then Include(Result, PGPKeyProp_SecShared);
  if KeyPropsFlag and spgpKeyProp_CanEncrypt<>0 then Include(Result, PGPKeyProp_CanEncrypt);
  if fPGP6X and (KeyPropsFlag and spgpKeyProp_CanDecrypt<>0) then Include(Result, PGPKeyProp_CanDecrypt);
  if KeyPropsFlag and spgpKeyProp_CanSign<>0 then Include(Result, PGPKeyProp_CanSign);
  if fPGP6X and (KeyPropsFlag and spgpKeyProp_CanVerify<>0) then Include(Result, PGPKeyProp_CanVerify);
  if KeyPropsFlag and spgpKeyProp_HasRevoker<>0 then Include(Result, PGPKeyProp_HasRevoker);
  if KeyPropsFlag and spgpKeyProp_HasADK<>0 then Include(Result, PGPKeyProp_HasADK);
  if KeyPropsFlag and spgpKeyProp_HasSubKey<>0 then Include(Result, PGPKeyProp_HasSubKey);
end;

function GetKeyPropsFlag(const setKeyProps: TKeyProps): TKeyPropsFlag;
var fPGP6X: Boolean;
begin
  fPGP6X:=PGP6X;
  Result:=
    ord(PGPKeyProp_HexID in setKeyProps) * spgpKeyProp_KeyID or
    ord(PGPKeyProp_UserID in setKeyProps) * spgpKeyProp_UserID or
    ord(PGPKeyProp_Fingerprint in setKeyProps) * spgpKeyProp_Fingerprint or
    ord(PGPKeyProp_CreaTimeStr in setKeyProps) * spgpKeyProp_CreationTimeStr or
    ord(PGPKeyProp_ExpTimeStr in setKeyProps) * spgpKeyProp_ExpirationTimeStr or
    ord(PGPKeyProp_Size in setKeyProps) * spgpKeyProp_Keybits or
    ord(PGPKeyProp_Algorithm in setKeyProps) * spgpKeyProp_KeyAlg or
    ord(PGPKeyProp_Trust in setKeyProps) * spgpKeyProp_Trust or
    ord(PGPKeyProp_Validity in setKeyProps) * spgpKeyProp_Validity or
    ord(PGPKeyProp_CreaTimeNum in setKeyProps) * spgpKeyProp_CreationTime or
    ord(PGPKeyProp_ExpTimeNum in setKeyProps) * spgpKeyProp_ExpirationTime or
    ord(PGPKeyProp_Secret in setKeyProps) * spgpKeyProp_IsSecret or
    ord(PGPKeyProp_ImplicitTrust in setKeyProps) * spgpKeyProp_IsAxiomatic or
    ord(PGPKeyProp_Revoked in setKeyProps) * spgpKeyProp_IsRevoked or
    ord(PGPKeyProp_Disabled in setKeyProps) * spgpKeyProp_IsDisabled or
    ord(PGPKeyProp_Expired in setKeyProps) * spgpKeyProp_IsExpired or
    ord(fPGP6X and (PGPKeyProp_SecShared in setKeyProps)) * spgpKeyProp_IsSecretShared or
    ord(PGPKeyProp_CanEncrypt in setKeyProps) * spgpKeyProp_CanEncrypt or
    ord(fPGP6X and (PGPKeyProp_CanDecrypt in setKeyProps)) * spgpKeyProp_CanDecrypt or
    ord(PGPKeyProp_CanSign in setKeyProps) * spgpKeyProp_CanSign or
    ord(fPGP6X and (PGPKeyProp_CanVerify in setKeyProps)) * spgpKeyProp_CanVerify or
    ord(PGPKeyProp_HasRevoker in setKeyProps) * spgpKeyProp_HasRevoker or
    ord(PGPKeyProp_HasADK in setKeyProps) * spgpKeyProp_HasADK or
    ord(PGPKeyProp_HasSubKey in setKeyProps) * spgpKeyProp_HasSubKey;
end;

function ExtractKeyProps(const sKeyProps: String; setKeyProps: TKeyProps): TKeyRec;
var sBuffer: String; fPGP6X: Boolean;
begin
  FillChar(Result, SizeOf(TKeyRec), 0);
  if (sKeyProps<>EMPTY) and (setKeyProps<>[]) then with Result do begin
    sBuffer:=sKeyProps;
    fPGP6X:=PGP6X;
    try
      if PGPKeyProp_HexID in setKeyProps then kHexID:=TabExtract(sBuffer);
      if PGPKeyProp_UserID in setKeyProps then kUserID:=TabExtract(sBuffer);
      if PGPKeyProp_Fingerprint in setKeyProps then kFingerprint:=TabExtract(sBuffer);
      if PGPKeyProp_CreaTimeStr in setKeyProps then kCreaTimeStr:=TabExtract(sBuffer);
      if PGPKeyProp_ExpTimeStr in setKeyProps then kExpTimeStr:=TabExtract(sBuffer);
      if PGPKeyProp_Size in setKeyProps then kSize:=TabExtract(sBuffer);
      if PGPKeyProp_Algorithm in setKeyProps then kAlgorithm:=TKeyAlg(StrToInt(TabExtract(sBuffer)));
      if PGPKeyProp_Trust in setKeyProps then kTrust:=TTrustLevel(StrToInt(TabExtract(sBuffer)));
      if PGPKeyProp_Validity in setKeyProps then kValidity:=TValidityLevel(StrToInt(TabExtract(sBuffer)));
      if PGPKeyProp_CreaTimeNum in setKeyProps then kCreaTimeNum:=StrToInt(TabExtract(sBuffer));
      if PGPKeyProp_ExpTimeNum in setKeyProps then kExpTimeNum:=StrToInt(TabExtract(sBuffer));
      if PGPKeyProp_Secret in setKeyProps then kType:=TKeyType(StrToInt(TabExtract(sBuffer)));
      if PGPKeyProp_ImplicitTrust in setKeyProps then kImplicitTrust:=(TabExtract(sBuffer)=IsTrue);
      if PGPKeyProp_Revoked in setKeyProps then kRevoked:=(TabExtract(sBuffer)=IsTrue);
      if PGPKeyProp_Disabled in setKeyProps then kDisabled:=(TabExtract(sBuffer)=IsTrue);
      if PGPKeyProp_Expired in setKeyProps then kExpired:=(TabExtract(sBuffer)=IsTrue);
      if fPGP6X and (PGPKeyProp_SecShared in setKeyProps) then kSecShared:=(TabExtract(sBuffer)=IsTrue);
      if PGPKeyProp_CanEncrypt in setKeyProps then kCanEncrypt:=(TabExtract(sBuffer)=IsTrue);
      if fPGP6X and (PGPKeyProp_CanDecrypt in setKeyProps) then kCanDecrypt:=(TabExtract(sBuffer)=IsTrue);
      if PGPKeyProp_CanSign in setKeyProps then kCanSign:=(TabExtract(sBuffer)=IsTrue);
      if fPGP6X and (PGPKeyProp_CanVerify in setKeyProps) then kCanVerify:=(TabExtract(sBuffer)=IsTrue);
      if PGPKeyProp_HasRevoker in setKeyProps then kHasRevoker:=(TabExtract(sBuffer)=IsTrue);
      if PGPKeyProp_HasADK in setKeyProps then kHasADK:=(TabExtract(sBuffer)=IsTrue);
      if PGPKeyProp_HasSubKey in setKeyProps then kHasSubKey:=(TabExtract(sBuffer)=IsTrue);
    except
      Raise EKeyPropsError.Create('Invalid KeyProps string:' + CRLF + sKeyProps);
    end;
  end;
end;

function GetKeyResult(const sKeyProps: String): TKeyRec;
var sBuffer: String;
begin
  FillChar(Result, SizeOf(TKeyRec), 0);
  if sKeyProps<>EMPTY then with Result do begin
    sBuffer:=sKeyProps;
    try
      if sBuffer<>EMPTY then kType:=TKeyType(StrToInt(TabExtract(sBuffer)));
      if sBuffer<>EMPTY then kHexID:=TabExtract(sBuffer);
      if sBuffer<>EMPTY then kUserID:=TabExtract(sBuffer);
      if sBuffer<>EMPTY then kSize:=TabExtract(sBuffer);
      if sBuffer<>EMPTY then kCreaTimeStr:=TabExtract(sBuffer);
      if sBuffer<>EMPTY then kCreaTimeNum:=StrToInt(TabExtract(sBuffer));
      if sBuffer<>EMPTY then kFingerprint:=TabExtract(sBuffer);
      if sBuffer<>EMPTY then kTrust:=TTrustLevel(StrToInt(TabExtract(sBuffer)));
      if sBuffer<>EMPTY then kValidity:=TValidityLevel(StrToInt(TabExtract(sBuffer)));
      if sBuffer<>EMPTY then kAlgorithm:=TKeyAlg(StrToInt(TabExtract(sBuffer)));
    except
      Raise EKeyPropsError.Create('Invalid KeyProps string:' + CRLF + sKeyProps);
    end;
  end;
end;

function GetSigResult(const sSigProps: String): TSigRec;
var sBuffer: String;
begin
  FillChar(Result, SizeOf(TSigRec), 0);
  if sSigProps<>EMPTY then with Result do begin
    sBuffer:=sSigProps;
    try
      if sBuffer<>EMPTY then sStatus:=TSigStatus(StrToInt(TabExtract(sBuffer)));
      if sBuffer<>EMPTY then sUserID:=TabExtract(sBuffer);
      if sBuffer<>EMPTY then sHexID:=TabExtract(sBuffer);
      if sBuffer<>EMPTY then sCreaTimeStr:=TabExtract(sBuffer);
      if sBuffer<>EMPTY then sCreaTimeNum:=StrToInt(TabExtract(sBuffer));
      if sBuffer<>EMPTY then sChecked:=Boolean(StrToInt(TabExtract(sBuffer)));
      if sBuffer<>EMPTY then sVerified:=Boolean(StrToInt(TabExtract(sBuffer)));
      if sBuffer<>EMPTY then sValidity:=TValidityLevel(StrToInt(TabExtract(sBuffer)));
      if sBuffer<>EMPTY then sVerified:=Boolean(StrToInt(TabExtract(sBuffer)));
      if sBuffer<>EMPTY then sRevoked:=Boolean(StrToInt(TabExtract(sBuffer)));
      if sBuffer<>EMPTY then sDisabled:=Boolean(StrToInt(TabExtract(sBuffer)));
      if sBuffer<>EMPTY then sExpired:=Boolean(StrToInt(TabExtract(sBuffer)));
    except
      Raise ESigPropsError.Create('Invalid SigProps string:' + CRLF + sSigProps);
    end;
  end;
end;

procedure WipePassphrase(var Passphrase: String; const FOnWipePassphrase: TOnWipePassphrase);
begin
  try
    if Assigned(FOnWipePassphrase) then FOnWipePassphrase(Passphrase);
  finally
    if Passphrase<>EMPTY then FillChar(Passphrase[1], Length(Passphrase), 0);
  end;
end;

procedure ShowError(const FOnFailure: TOnFailure; ErrorCode: Longint; ErrorStr: String);
begin
  if Assigned(FOnFailure) then begin
    if ErrorStr=EMPTY then GetErrorString(ErrorCode, ErrorStr);
    FOnFailure(ErrorCode, ErrorStr);
  end
  else Raise EFailException.Create(ErrorStr);
end;

function ShowHexError(const FOnFailure: TOnFailure; const CompName, IDString: String): Boolean;
begin
  if (IDString<>EMPTY) and ((Length(IDString)<>10) or (pos('0x', LowerCase(IDString))<>1)) then begin
    ShowError(FOnFailure, -1, CompName + HexFormError + IDString);
    Result:=true;
  end
  else Result:=false;
end;

function ShowPathLengthError(const FOnFailure: TOnFailure; const CompName, Path: String): Boolean;
begin
  if Length(Path)>MAX_PATH then begin
    ShowError(FOnFailure, -1, CompName + PathLengthError + IntToStr(MAX_PATH));
    Result:=true;
  end
  else Result:=false;
end;

function GetSelKeyProps(FOnFailure: TOnFailure; const KeyID: String; var rKeyProps: TKeyRec): Boolean;
var
  ErrorCode: Longint;
  KeyPropsLen: Longint;
  KeyPropsStr: String;
  KeyProps: TKeyProps;
begin
  Result:=false;
  FillChar(rKeyProps, SizeOf(TKeyRec), 0);
  if KeyID<>EMPTY then begin
    KeyProps:=[PGPKeyProp_UserID, PGPKeyProp_Secret, PGPKeyProp_Revoked, PGPKeyProp_Disabled, PGPKeyProp_Expired];
    KeyPropsStr:=IntToStr(GetKeyPropsFlag(KeyProps));
    KeyPropsLen:=256;
    repeat
      ErrorCode:=SPGP.KeyProps(KeyID, KeyPropsStr, KeyPropsLen);
      KeyPropsLen:=ErrorCode;
    until ErrorCode<=0;
    if ErrorCode<0 then
      ShowError(FOnFailure, ErrorCode, EMPTY)
    else begin
      rKeyProps:=ExtractKeyProps(KeyPropsStr, KeyProps);
      with rKeyProps do begin
	if kRevoked or kDisabled or kExpired or (kType<>PGPPrivate) then
	  ShowError(FOnFailure, -1, NoPrivateKeyErr)
	else Result:=true;
      end;
    end;
  end;
end;

// TSignKey --------------------------------------------------------------------

procedure TSignKey.SetKeyHexID(const Value: String);
begin
  if (Value<>EMPTY) and (pos('0x', LowerCase(Value))<>1) then
    Raise EHexFormatError.Create(Self.Name + HexFormError + Value)
  else FKeyHexID:=Value;
end;

procedure TSignKey.SetSignHexID(const Value: String);
begin
  if (Value<>EMPTY) and (pos('0x', LowerCase(Value))<>1) then
    Raise EHexFormatError.Create(Self.Name + HexFormError + Value)
  else FSignHexID:=Value;
end;

// TIDLists --------------------------------------------------------------------

constructor TIDLists.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FHexIDList:=TStringList.Create;
  FUserIDList:=TStringList.Create;
  FRingPropsList:=TStringList.Create;
end;

destructor TIDLists.Destroy;
begin
  FHexIDList.Free;
  FUserIDList.Free;
  FRingPropsList.Free;
  inherited Destroy;
end;

procedure TIDLists.Clear;
begin
  FHexIDList.Clear;
  FUserIDList.Clear;
  FRingPropsList.Clear;
end;

function TIDLists.GetKeyKind(const rKeyProps: TKeyRec): TKeyKind;
begin
  Result:=PGPPublicKey_Invalid;
  case rKeyProps.kAlgorithm of
    PGPPublicKeyAlgorithm_RSA..PGPPublicKeyAlgorithm_ElGamal: Result:=TKeyKind(rKeyProps.kAlgorithm);
    PGPPublicKeyAlgorithm_DSA: begin
      if pos(SLASH, rKeyProps.kSize)<>0 then
	Result:=PGPPublicKey_DHDSS
      else Result:=PGPPublicKey_DSA;
    end;
  end;
end;

procedure TIDLists.Add(const KeyPropsStr: String);
var rKeyProps: TKeyRec; iKeyFlags: Longint;
begin
 rKeyProps:=ExtractKeyProps(KeyPropsStr, FRingProps);
 iKeyFlags:=ord(GetKeyKind(rKeyProps));
  with rKeyProps do begin
    iKeyFlags:=iKeyFlags shl 16 + ord(kType);
    FHexIDList.Add(kHexID);
    FUserIDList.Add(kUserID);
    FRingPropsList.AddObject(KeyPropsStr, ptr(iKeyFlags));
  end;
end;

function TIDLists.KeyType(const KeyHexID: String): TKeyType;
var iIndex: Longint;
begin
  Result:=PGPPublic;
  if (KeyHexID<>EMPTY) and not ShowHexError(FOnFailure,  Self.Name, KeyHexID) then begin
    iIndex:=FHexIDList.IndexOf(KeyHexID);
    if iIndex<>-1 then Result:=TKeyType(LoWord(Longint(FRingPropsList.Objects[iIndex])));
  end;
end;

function TIDLists.KeyKind(const KeyHexID: String): TKeyKind;
var iIndex: Longint;
begin
  Result:=PGPPublicKey_Invalid;
  if (KeyHexID<>EMPTY) and not ShowHexError(FOnFailure,  Self.Name, KeyHexID) then begin
    iIndex:=FHexIDList.IndexOf(KeyHexID);
    if iIndex<>-1 then Result:=TKeyKind(HiWord(Longint(FRingPropsList.Objects[iIndex])));
  end;
end;

function TIDLists.ExtractRingProps(const KeyHexID: String): TKeyRec;
var iIndex: Longint;
begin
  FillChar(Result, SizeOf(TKeyRec), 0);
  if (KeyHexID<>EMPTY) and not ShowHexError(FOnFailure,  Self.Name, KeyHexID) then begin
    iIndex:=FHexIDList.IndexOf(KeyHexID);
    if iIndex<>-1 then Result:=ExtractKeyProps(FRingPropsList.Strings[iIndex], FRingProps);
  end;
end;

// TPGPGetKeyProps -------------------------------------------------------------

constructor TPGPGetKeyProps.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FKeyPropsList:=TStringList.Create;
end;

destructor TPGPGetKeyProps.Destroy;
begin
  FKeyPropsList.Free;
  inherited Destroy;
end;

procedure TPGPGetKeyProps.GetKeyLists(var KeyPropsStr: String);
var
  sKeyProps: String;
  rKeyProps: TKeyRec;
  slSortBuffer: TStringList;
  iIndex: Longint;
begin
  Clear;
  slSortBuffer:=TStringList.Create;
  try
    while KeyPropsStr<>EMPTY do begin
      sKeyProps:=GetLine(KeyPropsStr);
      rKeyProps:=ExtractKeyProps(sKeyProps, FRingProps);
      with rKeyProps do slSortBuffer.Add(kUserID + BSLASH + sKeyProps);
    end;
    with slSortBuffer do begin
      if Count<>0 then Sort;
      for iIndex:=0 to pred(Count) do begin
	sKeyProps:=Strings[iIndex];
	sKeyProps:=Copy(sKeyProps, succ(pos(BSLASH, sKeyProps)), Length(sKeyProps));
	Self.Add(sKeyProps);
      end;
    end;
  finally
    slSortBuffer.Free;
  end;
end;

procedure TPGPGetKeyProps.Update;
var
  ErrorCode: Longint;
  KeyPropsLen: Longint;
  KeyPropsStr: String;
  KeyPropsFlag: Longint;
begin
  try
    KeyPropsLen:=SPGP.KeyRingCount;
    if KeyPropsLen>0 then begin
      KeyPropsLen:=KeyPropsLen*512;
      FKeyProps:=FKeyProps +
      		 [PGPKeyProp_HexID, PGPKeyProp_UserID, PGPKeyProp_Secret, PGPKeyProp_Size, PGPKeyProp_Algorithm];
      KeyPropsFlag:=GetKeyPropsFlag(KeyProps);
      KeyPropsStr:=IntToStr(KeyPropsFlag);
      repeat
	ErrorCode:=KeyRingID(KeyPropsStr, KeyPropsLen);
	KeyPropsLen:=ErrorCode;
      until ErrorCode<=0;
      if ErrorCode=0 then begin
        FRingProps:=FKeyProps;
	GetKeyLists(KeyPropsStr);
	if Assigned(FComboBox) then FComboBox.Items.Assign(FUserIDList);
	if Assigned(FListBox) then FListBox.Items.Assign(FUserIDList);
      end
      else ShowError(FOnFailure, ErrorCode, EMPTY);
    end;
  except
    on EKeyPropsError do Raise;
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownGetRingIDErr);
  end;
end;

function TPGPGetKeyProps.DoGetKeyProps: Longint;
var
  KeyPropsLen: Longint;
  KeyPropsStr: String;
  KeyPropsFlag: TKeyPropsFlag;
  KeyPropsRec: TKeyRec;
begin
  Result:=-1;
  try
    FKeyProps:=FKeyProps + [PGPKeyProp_Secret];
    KeyPropsFlag:=GetKeyPropsFlag(FKeyProps);
    if Assigned(FOnGetKeyID) then FOnGetKeyID(FKeyID);
    if (FKeyID<>EMPTY) and ((KeyPropsFlag<>0) or CompatibilityMode) then begin
      if CompatibilityMode then
	KeyPropsStr:=#0
      else KeyPropsStr:=IntToStr(KeyPropsFlag);
      KeyPropsLen:=512;
      repeat
	Result:=SPGP.KeyProps(FKeyID, KeyPropsStr, KeyPropsLen);
	KeyPropsLen:=Result;
      until Result<=0;
      if Result=0 then with FKeyPropsList do begin
	Text:=KeyPropsStr;
	if Count=1 then begin
	  if CompatibilityMode then
	    KeyPropsRec:=GetKeyResult(Strings[0])
	  else KeyPropsRec:=ExtractKeyProps(Strings[0], FKeyProps);
	  Result:=ord(KeyPropsRec.kType);
	end;
	if Assigned(FOnGetKeyProps) then FOnGetKeyProps(FKeyPropsList);
      end
      else ShowError(FOnFailure, Result, EMPTY);
    end;
  except
    on EKeyPropsError do Raise;
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownGetPropsErr);
  end;
end;

function TPGPGetKeyProps.DoGetKeyPropSig: Longint;
var KeyPropsLen: Longint; KeyPropsStr: String;
begin
  Result:=-1;
  try
    if Assigned(FOnGetUserID) then FOnGetUserID(FUserID);
    if FUserID<>EMPTY then begin
      KeyPropsLen:=1024;
      repeat
	Result:=KeyPropSig(FUserID, KeyPropsStr, KeyPropsLen);
	KeyPropsLen:=Result;
      until Result<=0;
      if Result=0 then begin
	if Assigned(FOnGetKeyPropSig) then FOnGetKeyPropSig(KeyPropsStr);
      end
      else ShowError(FOnFailure, Result, EMPTY);
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownGetPropSigErr);
  end;
end;

function TPGPGetKeyProps.DoGetKeyPropUserID: Longint;
var KeyPropsLen: Longint; KeyPropsStr: String;
begin
  Result:=-1;
  try
    if Assigned(FOnGetKeyID) then FOnGetKeyID(FKeyID);
    if FKeyID<>EMPTY then begin
      KeyPropsLen:=2048;
      repeat
	Result:=KeyPropUserID(FKeyID, KeyPropsStr, KeyPropsLen);
	KeyPropsLen:=Result;
      until Result<=0;
      if Result=0 then begin
	if Assigned(FOnGetKeyPropUserID) then FOnGetKeyPropUserID(KeyPropsStr);
      end
      else ShowError(FOnFailure, Result, EMPTY);
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownGetPropUserIDErr);
  end;
end;

function TPGPGetKeyProps.DoGetKeyPropADK: Longint;
var
  KeyPropsLen: Longint;
  KeyPropsStr: String;
  KeyPropsFlag: TKeyPropsFlag;
  ADKeyCount: Longint;
begin
  Result:=-1;
  try
    FKeyProps:=FKeyProps + [PGPKeyProp_HexID];
    KeyPropsFlag:=GetKeyPropsFlag(FKeyProps);
    if Assigned(FOnGetKeyID) then FOnGetKeyID(FKeyID);
    if FKeyID<>EMPTY then begin
      if not ShowHexError(FOnFailure, Self.Name, FKeyID) then begin
	if (KeyKind(FKeyID)=PGPPublicKey_DHDSS) then begin
	  KeyPropsLen:=1024;
	  repeat
	    Result:=KeyPropADK(FKeyID, KeyPropsStr, KeyPropsLen, ADKeyCount, KeyPropsFlag);
	    KeyPropsLen:=Result;
	  until Result<=0;
	  if Result=0 then begin
	    if KeyPropsStr<>EMPTY then begin
	      FKeyPropsList.Text:=KeyPropsStr;
	      if Assigned(FOnGetKeyProps) then FOnGetKeyProps(FKeyPropsList);
	    end;
	    Result:=ADKeyCount;
	  end
	  else ShowError(FOnFailure, Result, EMPTY);
	end
	else Result:=0;
      end;
    end;
  except
    on EKeyPropsError do Raise;
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownGetPropADKErr);
  end;
end;

function TPGPGetKeyProps.DoGetKeyPropRevokationKey: Longint;
var
  KeyPropsLen: Longint;
  KeyPropsStr: String;
  KeyPropsFlag: TKeyPropsFlag;
  RevKeyCount: Longint;
begin
  Result:=-1;
  try
    FKeyProps:=FKeyProps + [PGPKeyProp_HexID];
    KeyPropsFlag:=GetKeyPropsFlag(FKeyProps);
    if FKeyID<>EMPTY then begin
      if not ShowHexError(FOnFailure, Self.Name, FKeyID) then begin
	if KeyKind(FKeyID)=PGPPublicKey_DHDSS then begin
	  KeyPropsLen:=1024;
	  repeat
	    Result:=KeyPropRevocationKey(FKeyID, KeyPropsStr, KeyPropsLen, RevKeyCount, KeyPropsFlag);
	    KeyPropsLen:=Result;
	  until Result<=0;
	  if Result=0 then begin
	    if KeyPropsStr<>EMPTY then begin
	      FKeyPropsList.Text:=KeyPropsStr;
	      if Assigned(FOnGetKeyProps) then FOnGetKeyProps(FKeyPropsList);
	    end;
	    Result:=RevKeyCount;
	  end
	  else ShowError(FOnFailure, Result, EMPTY);
	end
	else Result:=0;
      end;
    end;
  except
    on EKeyPropsError do Raise;
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownGetPropRevocationKeyErr);
  end;
end;

function TPGPGetKeyProps.DoGetKeyRingToFile: Longint;
begin
  Result:=-1;
  try
    if Assigned(FOnGetFileOut) then FOnGetFileOut(FFileOut);
    if FFileOut<>EMPTY then begin
      Result:=KeyRingToFile(FFileOut);
      if Result=0 then begin
        if Assigned(FOnGetKeyRingToFile) then FOnGetKeyRingToFile(FFileOut);
      end
      else ShowError(FOnFailure, Result, EMPTY);
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownGetRingToFileErr);
  end;
end;

function TPGPGetKeyProps.KeyIsOnRing: Boolean;
begin
  Result:=false;
  try
    if Assigned(FOnGetKeyID) then FOnGetKeyID(FKeyID);
    if FKeyID<>EMPTY then Result:=SPGP.KeyIsOnRing(FKeyID);
  except
    else ShowError(FOnFailure, -1, UnknownKeyIsOnRingErr);
  end;
end;

function TPGPGetKeyProps.KeyRingCount: Longint;
begin
  Result:=-1;
  try
    Result:=SPGP.KeyRingCount;
    if Result<0 then ShowError(FOnFailure, Result, EMPTY);
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeyRingCountErr);
  end;
end;

// TPGPSetKeyProps -------------------------------------------------------------

constructor TPGPSetKeyProps.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  MinPassLen:=10;
  MinPassQual:=100;
end;

destructor TPGPSetKeyProps.Destroy;
begin
  inherited Destroy;
end;

function TPGPSetKeyProps.DoKeyDisable: Longint;
begin
  Result:=-1;
  try
    if Assigned(FOnGetKeyID) then FOnGetKeyID(FKeyID);
    if FKeyID<>EMPTY then begin
      Result:=KeyDisable(FKeyID);
      if Result<0 then
	ShowError(FOnFailure, Result, EMPTY)
      else if Assigned(FGetKeyProps) then FGetKeyProps.Update;
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeyDisableErr);
  end;
end;

function TPGPSetKeyProps.DoKeyEnable: Longint;
begin
  Result:=-1;
  try
    if Assigned(FOnGetKeyID) then FOnGetKeyID(FKeyID);
    if FKeyID<>EMPTY then begin
      Result:=KeyEnable(FKeyID);
      if Result<0 then
	ShowError(FOnFailure, Result, EMPTY)
      else if Assigned(FGetKeyProps) then FGetKeyProps.Update;
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeyEnableErr);
  end;
end;

function TPGPSetKeyProps.DoKeyRemove: Longint;
begin
  Result:=-1;
  try
    if Assigned(FOnGetKeyID) then FOnGetKeyID(FKeyID);
    if FKeyID<>EMPTY then begin
      Result:=KeyRemove(FKeyID);
      if Result<0 then
	ShowError(FOnFailure, Result, EMPTY)
      else if Assigned(FGetKeyProps) then FGetKeyProps.Update;
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeyRemoveErr);
  end;
end;

function TPGPSetKeyProps.DoKeyPassChange: Longint;
var OldPhrase, NewPhrase: String; rKeyProps: TKeyRec;
begin
  Result:=-1;
  OldPhrase:=EMPTY;
  NewPhrase:=EMPTY;
  try
    try
      if PGP6X and FStandardDlg then begin
	Result:=UIKeyPassphraseDialog(FKeyID, OldPhrase, ParentHandle);
	if Result=0 then Result:=UIConfirmationPassphraseDialog(NewPhrase, true, FMinPassQual, FMinPassLen, ParentHandle);
	if Result=0 then Result:=KeyPassChange(FKeyID, OldPhrase, NewPhrase);
	if (Result<0) and (Result<>kPGPError_UserAbort) then ShowError(FOnFailure, Result, EMPTY);
      end
      else begin
	if Assigned(FOnGetKeyID) then FOnGetKeyID(FKeyID);
	if GetSelKeyProps(FOnFailure, FKeyID, rKeyProps) and Assigned(FOnGetPass) then begin
	  FOnGetPass(rKeyProps, FMinPassLen, FMinPassQual, OldPhrase, NewPhrase);
	  if (OldPhrase<>EMPTY) and (NewPhrase<>EMPTY) then begin
	    Result:=EstimatePassphraseQuality(NewPhrase);
	    if Length(NewPhrase)<ord(FMinPassLen) then
	      ShowError(FOnFailure, ord(FMinPassLen), LowPassLenErr)
	    else if Result>0 then begin
	      if Result<ord(FMinPassQual) then
		ShowError(FOnFailure, ord(FMinPassQual), LowPassQualErr)
	      else Result:=KeyPassChange(FKeyID, OldPhrase, NewPhrase);
	    end;
	    if Result<0 then ShowError(FOnFailure, Result, EMPTY);
	  end;
	end;
      end;
    finally
      WipePassphrase(OldPhrase, nil);
      WipePassphrase(NewPhrase, nil);
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeyPassChangeErr);
  end;
end;

// TPGPKeySign -----------------------------------------------------------------

constructor TPGPKeySign.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

destructor TPGPKeySign.Destroy;
begin
  inherited Destroy;
end;

function TPGPKeySign.DoKeySign: Longint;
var KeyPropsStr: String; KeyPropsLen: Longint; rKeyProps: TKeyRec;
begin
  Result:=-1;
  FSignKeyPass:=EMPTY;
  try
    if Assigned(FOnGetKeyHexID) then FOnGetKeyHexID(FKeyHexID);
    if Assigned(FOnGetUserID) then FOnGetUserID(FUserID);
    if Assigned(FOnGetSignHexID) then FOnGetSignHexID(FSignHexID);
    if not (ShowHexError(FOnFailure, Self.Name, FKeyHexID) or ShowHexError(FOnFailure, Self.Name, FSignHexID)) then begin
      if GetSelKeyProps(FOnFailure, FSignHexID, rKeyProps) and Assigned(FOnGetSignKeyPass) then begin
	FOnGetSignKeyPass(rKeyProps, FSignKeyPass);
	if FSignKeyPass<>EMPTY then begin
	  try
	    Result:=KeySign(FKeyHexID, FUserID, FSignHexID, FSignKeyPass,
			    FExpires, FExportable, ord(FTrust), ord(FValidity));
	  finally
	    WipePassphrase(FSignKeyPass, FOnWipePassphrase);
	  end;
	  if Result=0 then begin
	    KeyPropsLen:=1024;
	    repeat
	      Result:=KeyPropSig(FUserID, KeyPropsStr, KeyPropsLen);
	      KeyPropsLen:=Result;
	    until Result<=0;
	  end;
	  if Result=0 then begin
	    if Assigned(FOnKeySigned) then FOnKeySigned(KeyPropsStr);
	  end
	  else ShowError(FOnFailure, Result, EMPTY)
	end;
      end;
    end;
  except
    on EKeyPropsError do Raise;
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeySignErr);
  end;
end;

// TPGPKeySigRemove ------------------------------------------------------------

constructor TPGPKeySigRemove.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

destructor TPGPKeySigRemove.Destroy;
begin
  inherited Destroy;
end;

function TPGPKeySigRemove.DoKeySigRemove: Longint;
var KeyPropsLen: Longint; KeyPropsStr: String;
begin
  Result:=-1;
  try
    if Assigned(FOnGetKeyHexID) then FOnGetKeyHexID(FKeyHexID);
    if ShowHexError(FOnFailure, Self.Name, FKeyHexID) then Exit;
    if Assigned(FOnGetUserID) then FOnGetUserID(FUserID);
    if Assigned(FOnGetSignHexID) then FOnGetSignHexID(FSignHexID);
    if ShowHexError(FOnFailure, Self.Name, FSignHexID) then Exit;
    Result:=KeySigRemove(FKeyHexID, FUserID, FSignHexID);
    if Result=0 then begin
      KeyPropsLen:=1024;
      repeat
        Result:=KeyPropSig(FUserID, KeyPropsStr, KeyPropsLen);
        KeyPropsLen:=Result;
      until Result<=0;
    end;
    if Result=0 then begin
      if Assigned(FOnKeySigRemoved) then FOnKeySigRemoved(KeyPropsStr);
    end
    else ShowError(FOnFailure, Result, EMPTY)
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeySigRemoveErr);
  end;
end;

// TPGPKeyImport ---------------------------------------------------------------

constructor TPGPKeyImport.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FKeyPropsList:=TStringList.Create;
end;

destructor TPGPKeyImport.Destroy;
begin
  FKeyPropsList.Free;
  inherited Destroy;
end;

function TPGPKeyImport.DoKeyImport(const BufferIn: String): Longint;
var KeyCount, KeyPropsLen: Longint; KeyPropsStr: String;
begin
  Result:=-1;
  try
    KeyCount:=SPGP.KeyRingCount;
    KeyPropsLen:=256;
    repeat
      Result:=_KeyImport(BufferIn, KeyPropsStr, KeyPropsLen, FImport, true);
      KeyPropsLen:=Result;
    until Result<=0;
    KeyCount:=SPGP.KeyRingCount - KeyCount;
    if (Result=0) or ((Result=kPGPError_FilePermissions) and (KeyCount>0)) then begin
      FKeyPropsList.Text:=KeyPropsStr;
      if Assigned(FOnKeyImported) then FOnKeyImported(FKeyPropsList, KeyCount);
      if Import and Assigned(FGetKeyProps) then FGetKeyProps.Update;
    end
    else ShowError(FOnFailure, Result, EMPTY);
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeyImportErr);
  end;
end;

function TPGPKeyImport.DoKeyImportFile: Longint;
var KeyCount, KeyPropsLen: Longint; KeyPropsStr: String;
begin
  Result:=-1;
  try
    if Assigned(FOnGetFileIn) then FOnGetFileIn(FFileIn);
    if FFileIn<>EMPTY then begin
      KeyCount:=SPGP.KeyRingCount;
      KeyPropsLen:=256;
      repeat
	Result:=_KeyImportFile(FFileIn, KeyPropsStr, KeyPropsLen, FImport, true);
	KeyPropsLen:=Result;
      until Result<=0;
      KeyCount:=SPGP.KeyRingCount - KeyCount;
      if (Result=0) or ((Result=kPGPError_FilePermissions) and (KeyCount>0)) then begin
	FKeyPropsList.Text:=KeyPropsStr;
	if Assigned(FOnKeyImported) then FOnKeyImported(FKeyPropsList, KeyCount);
	if Import and Assigned(FGetKeyProps) then FGetKeyProps.Update;
      end
      else ShowError(FOnFailure, Result, EMPTY);
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeyImportErr);
  end;
end;

// TPGPKeyExport ---------------------------------------------------------------

constructor TPGPKeyExport.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FKeyIDs:=TStringList.Create;
end;

destructor TPGPKeyExport.Destroy;
begin
  FKeyIDs.Free;
  inherited Destroy;
end;

function TPGPKeyExport.DoKeyExport: Longint;
var KeyPropsLen: Longint; KeyPropsStr: String;
begin
  Result:=-1;
  try
    if Assigned(FOnGetKeyIDs) then begin
      FKeyIDs.Clear;
      FOnGetKeyIDs(FKeyIDs);
    end;
    if FKeyIDs.Count<>0 then begin
      KeyPropsLen:=1024;
      repeat
	Result:=KeyExport(FKeyIDs.CommaText, KeyPropsStr, KeyPropsLen, FExpPrivate, FExpCompatible);
        KeyPropsLen:=Result;
      until Result<=0;
      if Result=0 then begin
        if Assigned(FOnKeyExported) then FOnKeyExported(KeyPropsStr, EMPTY);
      end
      else ShowError(FOnFailure, Result, EMPTY);
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeyExportErr);
  end;
  FKeyIDs.Clear;
end;

function TPGPKeyExport.DoKeyExportFile: Longint;
begin
  Result:=-1;
  try
    if Assigned(FOnGetFileOut) then FOnGetFileOut(FFileOut);
    if FFileOut<>EMPTY then begin
      if Assigned(FOnGetKeyIDs) then begin
        FKeyIDs.Clear;
        FOnGetKeyIDs(FKeyIDs);
      end;
      if FKeyIDs.Count<>0 then begin
        Result:=KeyExportFile(FKeyIDs.CommaText, FFileOut, FExpPrivate, FExpCompatible);
        if Result=0 then begin
          if Assigned(FOnKeyExported) then FOnKeyExported(EMPTY, FFileOut);
        end
        else ShowError(FOnFailure, Result, EMPTY);
      end;
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeyExportErr);
  end;
  FKeyIDs.Clear;
end;

// TPGPDetachedSigCreate -------------------------------------------------------

constructor TPGPDetachedSigCreate.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

destructor TPGPDetachedSigCreate.Destroy;
begin
  inherited Destroy;
end;

procedure TPGPDetachedSigCreate.SetComment(const Value: String);
begin
  if not FArmor then
    FComment:=EMPTY
  else FComment:=Value;
end;

function TPGPDetachedSigCreate.GetSigningPass: Boolean;
var DefKeyID: String; ErrorCode: Longint; rKeyProps: TKeyRec;
begin
  Result:=false;
  FSignKeyPass:=EMPTY;
  try
    if PGP6X and FStandardDlg then begin
      DefKeyID:=FSignKeyID;
      ErrorCode:=UISigningPassphraseDialog(FSignKeyID, FSignKeyPass, DefKeyID, true, ParentHandle);
      if (ErrorCode<0) and (ErrorCode<>kPGPError_UserAbort) then ShowError(FOnFailure, ErrorCode, EMPTY);
    end
    else begin
      if GetSelKeyProps(FOnFailure, FSignKeyID, rKeyProps) and Assigned(FOnGetSignKeyPass) then begin
	FOnGetSignKeyPass(rKeyProps, FSignKeyPass);
      end;
    end;
    Result:=(FSignKeyPass<>EMPTY);
  except
    on EKeyPropsError do Raise;
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownSigCreateErr);
  end;
end;

function TPGPDetachedSigCreate.DoSigCreate: Longint;
begin
  Result:=-1;
  try
    if Assigned(FOnGetFileIn) then FOnGetFileIn(FFileIn);
    if FFileIn<>EMPTY then begin
      FSigFile:=FFileIn + '.sig';
      if Assigned(FOnGetSigFile) then FOnGetSigFile(FSigFile);
      if (FSigFile<>EMPTY) then begin
	if Assigned(FOnGetSignKeyID) then FOnGetSignKeyID(FSignKeyID);
	if GetSigningPass then begin
	  try
	    Result:=DetachedSigCreate(FFileIn, FSigFile, FSignKeyID, FSignKeyPass, FComment, ord(FSignAlg), FArmor);
	    if Result=0 then begin
	      if Assigned(FOnSigCreated) then FOnSigCreated(FSigFile);
	    end
	    else ShowError(FOnFailure, Result, EMPTY);
	  finally
	    WipePassphrase(FSignKeyPass, FOnWipePassphrase);
	  end;
	end;
      end;
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownSigCreateErr);
  end;
end;

// TPGPDetachedSigVerify -------------------------------------------------------

constructor TPGPDetachedSigVerify.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

destructor TPGPDetachedSigVerify.Destroy;
begin
  inherited Destroy;
end;

function TPGPDetachedSigVerify.DoSigVerify: Longint;
var SigProps: String; ErrorCode: Longint;
begin
  Result:=-1;
  try
    if Assigned(FOnGetSignedFile) then FOnGetSignedFile(FSignedFile);
    if FSignedFile<>EMPTY then begin
      FSigFile:=FSignedFile + '.sig';
      if Assigned(FOnGetSigFile) then FOnGetSigFile(FSigFile);
      if FSigFile<>EMPTY then begin
        ErrorCode:=DetachedSigVerify(FSigFile, FSignedFile, SigProps);
        if ErrorCode=0 then begin
          if Assigned(FOnSigVerified) then FOnSigVerified(GetSigResult(SigProps));
          Result:=StrToInt(SigProps[1]);
        end
        else ShowError(FOnFailure, ErrorCode, EMPTY);
      end;
    end;
  except
    on ESigPropsError do Raise;
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownSigVerifyErr);
  end;
end;

// TPGPEncode ------------------------------------------------------------------

constructor TPGPEncode.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCryptKeyIDs:=TStringList.Create;
end;

destructor TPGPEncode.Destroy;
begin
  FCryptKeyIDs.Free;
  inherited Destroy;
end;

function TPGPEncode.GetParams: Boolean;
var rKeyProps: TKeyRec;
begin
  Result:=true;
  if not FConventional then begin
    if FEncrypt and Assigned(FOnGetCryptKeyIDs) then begin
      FCryptKeyIDs.Clear;
      FOnGetCryptKeyIDs(FCryptKeyIDs);
    end;
    if FSign then begin
      if Assigned(FOnGetSignKeyID) then FOnGetSignKeyID(FSignKeyID);
      if GetSelKeyProps(FOnFailure, FSignKeyID, rKeyProps) and Assigned(FOnGetSignKeyPass) then begin
	FOnGetSignKeyPass(rKeyProps, FSignKeyPass);
      end;
    end;
  end
  else if Assigned(FOnGetConventionalPass) then FOnGetConventionalPass(FConventionalPass);
  if (FEncrypt and (FCryptKeyIDs.Count=0))
  or (FSign and (FSignKeyPass=EMPTY))
  or (FConventional and (FConventionalPass=EMPTY)) then Result:=false;
end;

function TPGPEncode.Call_Encode(const BufferIn: String; var BufferOut: String): Longint;
var BufferOutLen: Longint;
begin
  BufferOutLen:=$FFFF;
  repeat
    if PGP6X and FStandardDlg then begin
      Result:=UIEncode(BufferIn, BufferOut, BufferOutLen,
		       FEncrypt, FSign, ord(FSignAlg),
		       FConventional, ord(FConventionalAlg),
		       FClear, FCompress, FEyesOnly, FMime,
		       FComment, FMimeSeparator, FParentHandle);
    end
    else begin
      Result:=_Encode(BufferIn, BufferOut, BufferOutLen,
		      FEncrypt, FSign, ord(FSignAlg),
		      FConventional, ord(FConventionalAlg),
		      true, true, FClear,
		      FCompress, FEyesOnly, FMime,
		      FCryptKeyIDs.CommaText, FSignKeyID,
		      FSignKeyPass, FConventionalPass,
		      FComment, FMimeSeparator);
    end;
    BufferOutLen:=Result;
  until Result<=0;
end;

function TPGPEncode.Call_EncodeFile(const FileIn, FileOut: String): Longint;
begin
  if PGP6X and FStandardDlg then begin
    Result:=UIEncodeFile(FileIn, FileOut,
			 FEncrypt, FSign, ord(FSignAlg),
			 FConventional, ord(FConventionalAlg),
			 FArmor, FTextmode, FClear,
			 FCompress, FEyesOnly, FMime,
			 FComment, FMimeSeparator, FParentHandle);
  end
  else begin
    Result:=_EncodeFile(FileIn, FileOut,
			FEncrypt, FSign, ord(FSignAlg),
			FConventional, ord(FConventionalAlg),
			FArmor, FTextmode, FClear,
			FCompress, FEyesOnly, FMime,
			FCryptKeyIDs.Text, FSignKeyID,
			FSignKeyPass, FConventionalPass,
			FComment, FMimeSeparator);
  end;
end;

function TPGPEncode.DoEncode(const BufferIn: String): Longint;
var BufferOut: String;
begin
  Result:=-1;
  try
    try
      if ((not FConventional) and PGP6X and FStandardDlg) or GetParams then begin
	Result:=Call_Encode(BufferIn, BufferOut);
	if Result=0 then begin
	  if Assigned(FOnEncoded) then FOnEncoded(BufferOut, EMPTY);
	end
	else if Result<>kPGPError_UserAbort then ShowError(FOnFailure, Result, EMPTY);
      end;
    finally
      WipePassphrase(FSignKeyPass, FOnWipePassphrase);
    end;
  except
    on EKeyPropsError do Raise;
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownEncErr);
  end;
  FCryptKeyIDs.Clear;
end;

function TPGPEncode.DoEncodeFile: Longint;
begin
  Result:=-1;
  try
    if Assigned(FOnGetFileIn) then FOnGetFileIn(FFileIn);
    if FFileIn<>EMPTY then begin
      FFileOut:=FFileIn + '.pgp';
      if Assigned(FOnGetFileOut) then FOnGetFileOut(FFileOut);
      if FFileOut<>EMPTY then begin
        try
	  if ((not FConventional) and PGP6X and FStandardDlg) or GetParams then begin
	    Result:=Call_EncodeFile(FFileIn, FFileOut);
	    if Result=0 then begin
	      if Assigned(FOnEncoded) then FOnEncoded(EMPTY, FFileOut);
	    end
	    else if Result<>kPGPError_UserAbort then ShowError(FOnFailure, Result, EMPTY);
	  end;
	finally
	  WipePassphrase(FSignKeyPass, FOnWipePassphrase);
	end;
      end;
    end;
  except
    on EKeyPropsError do Raise;
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownEncErr);
  end;
  FCryptKeyIDs.Clear;
end;

procedure TPGPEncode.SetArmor(Value: Boolean);
begin
  if Value<>FArmor then FArmor:=Value;
  if FArmor then FClear:=false;
end;

procedure TPGPEncode.SetClear(Value: Boolean);
begin
  if Value<>FClear then FClear:=Value;
  if FClear then begin
    FSign:=true;
    FMime:=false;
    FArmor:=false;
    FTextMode:=true;
    FEncrypt:=false;
    FCompress:=false;
    FConventional:=false;
  end;
end;

procedure TPGPEncode.SetComment(const Value: String);
begin
  if not FArmor then
    FComment:=EMPTY
  else FComment:=Value;
end;

procedure TPGPEncode.SetCompress(Value: Boolean);
begin
  if Value<>FCompress then FCompress:=Value;
  if FCompress then FClear:=false;
end;

procedure TPGPEncode.SetConventional(Value: Boolean);
begin
  if Value<>FConventional then FConventional:=Value;
  if FConventional then begin
    FEncrypt:=false;
    FClear:=false;
    FSign:=false;
  end;
end;

procedure TPGPEncode.SetEncrypt(Value: Boolean);
begin
  if Value<>FEncrypt then FEncrypt:=Value;
  if FEncrypt then begin
    FConventional:=false;
    FClear:=false;
  end;
end;

procedure TPGPEncode.SetMime(Value: Boolean);
begin
  if Value<>FMime then FMime:=Value;
  if FMime then begin
    FClear:=false;
    FArmor:=true;
  end;
end;

procedure TPGPEncode.SetSign(Value: Boolean);
begin
  if Value<>FSign then FSign:=Value;
  if FSign then FConventional:=false;
end;

// TPGPDecode ------------------------------------------------------------------

constructor TPGPDecode.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

destructor TPGPDecode.Destroy;
begin
  inherited Destroy;
end;

function TPGPDecode.CallDecode(const BufferIn: String; var BufferOut, SigProps: String): Longint;
var BufferOutLen: Longint;
begin
  BufferOutLen:=$FFFF;
  repeat
    Result:=Decode(BufferIn, BufferOut, BufferOutLen, FPassphrase, SigProps);
    BufferOutLen:=Result;
  until Result<=0;
end;

function TPGPDecode.CallDecodeFile(const FileIn, FileOut: String; var SigProps: String): Longint;
begin
  Result:=DecodeFile(FileIn, FileOut, FPassphrase, SigProps);
end;

function TPGPDecode.GetDecryptPassphrase(AnalysisRes: Longint; const Analysis: String): Boolean;
var
  AnalysisBuf, KeyID, KeyPropsStr: String;
  KeyPropsLen, ErrorCode: Longint;
  KeyProps: TKeyProps;
  rKeyProps: TKeyRec;
begin
  ErrorCode:=0;
  Result:=false;
  FPassphrase:=EMPTY;
  FillChar(rKeyProps, SizeOf(TKeyRec), 0);
  case AnalysisRes of
    PGPAnalyze_Encrypted: begin
      AnalysisBuf:=Analysis;
      GetLine(AnalysisBuf);
      GetLine(AnalysisBuf);
      while AnalysisBuf<>EMPTY do begin
	KeyProps:=[PGPKeyProp_UserID, PGPKeyProp_Secret, PGPKeyProp_Revoked, PGPKeyProp_Disabled, PGPKeyProp_Expired];
	KeyPropsStr:=IntToStr(GetKeyPropsFlag(KeyProps));
	KeyID:=TabExtract(AnalysisBuf);
	KeyPropsLen:=256;
	repeat
	  ErrorCode:=SPGP.KeyProps(KeyID, KeyPropsStr, KeyPropsLen);
	  KeyPropsLen:=ErrorCode;
	until ErrorCode<=0;
	if ErrorCode=0 then begin
	  rKeyProps:=ExtractKeyProps(KeyPropsStr, KeyProps);
	  with rKeyProps do begin
	    if not (kRevoked or kDisabled or kExpired) and (kType=PGPPrivate) then begin
	      if PGP6X and FStandardDlg then
		ErrorCode:=UIKeyPassphraseDialog(KeyID, FPassphrase, FParentHandle)
	      else if Assigned(FOnGetPassphrase) then FOnGetPassphrase(rKeyProps, FPassphrase);
	      Break;
	    end;
	  end;
	end;
      end;
      if (AnalysisBuf=EMPTY) and (rKeyProps.kType<>PGPPrivate) then ShowError(FOnFailure, -1, NoDecKeyErr);
    end;
    PGPAnalyze_Signed: begin
      Result:=true;
      Exit;
    end;
    PGPAnalyze_EncryptedNoKeys: ShowError(FOnFailure, -1, NoDecKeyErr);
    PGPAnalyze_EncryptedConventional: if Assigned(FOnGetPassphrase) then FOnGetPassphrase(rKeyProps, FPassphrase);
  end;
  try
    if (ErrorCode<0) and (ErrorCode<>kPGPError_UserAbort) then ShowError(FOnFailure, ErrorCode, EMPTY);
    Result:=(FPassphrase<>EMPTY);
  except
    on EKeyPropsError do Raise;
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownDecErr);
  end;
end;

function TPGPDecode.DoDecode(const BufferIn: String): Longint;
var BufferOut, SigProps: String; BufferOutLen, ErrorCode: Longint;
begin
  Result:=-1;
  try
    BufferOutLen:=256;
    repeat
      Result:=AnalyzeEx(BufferIn, BufferOut, BufferOutLen);
      BufferOutLen:=Result;
    until Result<=PGPAnalyze_Max;
    if GetDecryptPassphrase(Result, BufferOut) then begin
      try
	ErrorCode:=CallDecode(BufferIn, BufferOut, SigProps);
      finally
	WipePassphrase(FPassphrase, FOnWipePassphrase);
      end;
    end
    else Exit;
    if ErrorCode=0 then begin
      Result:=StrToInt(SigProps[1]);
      if Assigned(FOnDecoded) then FOnDecoded(BufferOut, EMPTY, GetSigResult(GetLine(SigProps)));
    end
    else ShowError(FOnFailure, ErrorCode, EMPTY);
  except
    on ESigPropsError do Raise;
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownDecErr);
  end;
end;

function TPGPDecode.DoDecodeFile: Longint;
var BufferOut, SigProps: String; BufferOutLen, ErrorCode: Longint;
begin
  Result:=-1;
  if Assigned(FOnGetFileIn) then FOnGetFileIn(FFileIn);
  if FFileIn<>EMPTY then begin
    if Assigned(FOnGetFileOut) then FOnGetFileOut(FFileOut);
    if FFileOut<>EMPTY then begin
      try
	BufferOutLen:=256;
	repeat
	  Result:=AnalyzeFileEx(FileIn, BufferOut, BufferOutLen);
	  BufferOutLen:=Result;
	until Result<=PGPAnalyze_Max;
	if GetDecryptPassphrase(Result, BufferOut) then begin
	  try
	    ErrorCode:=CallDecodeFile(FFileIn, FFileOut, SigProps);
	  finally
	    WipePassphrase(FPassphrase, FOnWipePassphrase);
	  end;
	end
	else Exit;
	if ErrorCode=0 then begin
	  Result:=StrToInt(SigProps[1]);
	  if Assigned(FOnDecoded) then FOnDecoded(EMPTY, FFileOut, GetSigResult(GetLine(SigProps)));
	end
	else ShowError(FOnFailure, ErrorCode, EMPTY);
      except
	on ESigPropsError do Raise;
	on EFailException do Raise;
	else ShowError(FOnFailure, -1, UnknownDecErr);
      end;
    end;
  end;
end;

// TPGPAnalyze -----------------------------------------------------------------

constructor TPGPAnalyze.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

destructor TPGPAnalyze.Destroy;
begin
  inherited Destroy;
end;

function TPGPAnalyze.DoAnalyze(const BufferIn: String): Longint;
var BufferOutLen: Longint; BufferOut: String;
begin
  Result:=-1;
  try
    BufferOutLen:=256;
    repeat
      Result:=AnalyzeEx(BufferIn, BufferOut, BufferOutLen);
      BufferOutLen:=Result;
    until Result<=PGPAnalyze_Max;
    if (Result>=PGPAnalyze_Min) and (Result<=PGPAnalyze_Max) then begin
      if Assigned(FOnGetAnalysis) then FOnGetAnalysis(BufferOut);
    end
    else ShowError(FOnFailure, Result, EMPTY);
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownAnalysisErr);
  end;
end;

function TPGPAnalyze.DoAnalyzeFile: Longint;
var BufferOutLen: Longint; BufferOut: String;
begin
  Result:=-1;
  try
    if Assigned(FOnGetFileIn) then FOnGetFileIn(FFileIn);
    if FFileIn<>EMPTY then begin
      BufferOutLen:=256;
      repeat
	Result:=AnalyzeFileEx(FileIn, BufferOut, BufferOutLen);
	BufferOutLen:=Result;
      until Result<=PGPAnalyze_Max;
      if (Result>=PGPAnalyze_Min) and (Result<=PGPAnalyze_Max) then begin
	if Assigned(FOnGetAnalysis) then FOnGetAnalysis(BufferOut);
      end
      else ShowError(FOnFailure, Result, EMPTY);
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownAnalysisErr);
  end;
end;

// TPGPPreferences -------------------------------------------------------------

constructor TPGPPreferences.Create;
begin
  inherited Create(AOwner);
end;

destructor TPGPPreferences.Destroy;
begin
  inherited Destroy;
end;

function TPGPPreferences.DoGetPreference: Longint;
var sPrefValue: String;
begin
  Result:=-1;
  FKeyHexID:=EMPTY;
  FFileName:=EMPTY;
  try
    Result:=GetPreference(ord(FPGPPref), sPrefValue);
    if Result<0 then
      ShowError(FOnFailure, Result, EMPTY)
    else begin
      if FPGPPref=PGPPref_DefaultKeyID then
        FKeyHexID:=sPrefValue
      else FFileName:=sPrefValue;
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownPrefsErr);
  end;
end;

function TPGPPreferences.DoSetPreference: Longint;
var sPrefValue: String;
begin
  Result:=-1;
  try
    if FPGPPref=PGPPref_DefaultKeyID then begin
      if Assigned(FOnGetKeyHexID) then FOnGetKeyHexID(FKeyHexID);
      sPrefValue:=FKeyHexID;
    end
    else begin
      if Assigned(FOnGetFileName) then FOnGetFileName(FFileName);
      sPrefValue:=FFileName;
    end;
    if ShowHexError(FOnFailure, Self.Name, FKeyHexID) then Exit;
    if sPrefValue<>EMPTY then begin
      Result:=SetPreference(ord(FPGPPref), sPrefValue);
      if Result<0 then
	ShowError(FOnFailure, Result, EMPTY)
      else if (FPGPPref<>PGPPref_DefaultKeyID) and Assigned(FGetKeyProps) then FGetKeyProps.Update;
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownPrefsErr);
  end;
end;

function TPGPPreferences.ShowPrefsDialog: Longint;
begin
  Result:=PreferencesDialog(ord(FPrefsPage), FParentHandle);
end;

function TPGPPreferences.SetKey(const KeyIDArray: TKeyHexIDArray; const KeyID: String): Boolean;
var rKeyProps: TKeyRec;
begin
  Result:=not ShowHexError(FOnFailure, Self.Name, KeyID) and GetSelKeyProps(FOnFailure, KeyID, rKeyProps);
  if Result then StrPLCopy(KeyIDArray, KeyID, 10);
end;

function TPGPPreferences.SetPath(const PathArray: TPathArray; const Path: String): Boolean;
begin
  Result:=not ShowPathLengthError(FOnFailure, Self.Name, Path);
  if Result then StrPLCopy(PathArray, Path, MAX_PATH);
end;

function TPGPPreferences.SetPrefs(const PrefsRec: TPreferenceRec): Boolean;
begin
  Result:=SetPath(PrefsRec.PublicKeyring, FPrefStrings.PublicKeyring) and
	  SetPath(PrefsRec.PrivateKeyring, FPrefStrings.PrivateKeyring) and
	  SetPath(PrefsRec.RandomSeedFile, FPrefStrings.RandomSeedFile) and
	  SetPath(PrefsRec.GroupsFile, FPrefStrings.GroupsFile) and
	  SetKey(PrefsRec.DefaultKeyHexID, FPrefStrings.DefaultKeyHexID);
end;

function TPGPPreferences.GetPrefs(const PrefsRec: TPreferenceRec): Boolean;
begin
  Result:=true;
  FPrefStrings.PublicKeyring:=PrefsRec.PublicKeyring;
  FPrefStrings.PrivateKeyring:=PrefsRec.PrivateKeyring;
  FPrefStrings.RandomSeedFile:=PrefsRec.RandomSeedFile;
  FPrefStrings.GroupsFile:=PrefsRec.GroupsFile;
  FPrefStrings.DefaultKeyHexID:=PrefsRec.DefaultKeyHexID;
end;

function TPGPPreferences.GetFlags: Longint;
begin
  Result:=ord(PGPPref_PublicKeyring in FPGPPrefs) * spgpPref_PublicKeyring or
	  ord(PGPPref_PrivateKeyring in FPGPPrefs) * spgpPref_PrivateKeyring or
	  ord(PGPPref_RandomSeedFile in FPGPPrefs) * spgpPref_RandomSeedFile or
	  ord(PGPPref_DefaultKeyID in FPGPPrefs) * spgpPref_DefaultKeyID or
	  ord(PGPPref_GroupsFile in FPGPPrefs) * spgpPref_GroupsFile;
end;

function TPGPPreferences.DoGetPreferences: Longint;
var PrefsRec: TPreferenceRec; PrefsFlag: Longint;
begin
  Result:=-1;
  FillChar(PrefsRec, SizeOf(TPreferenceRec), 0);
  try
    PrefsFlag:=GetFlags;
    if PrefsFlag<>0 then begin
      Result:=GetPreferences(PrefsRec, PrefsFlag);
      if Result<0 then
	ShowError(FOnFailure, Result, EMPTY)
      else if GetPrefs(PrefsRec) and Assigned(FOnGetPreferences) then FOnGetPreferences(FPrefStrings);
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownPrefsErr);
  end;
end;

function TPGPPreferences.DoSetPreferences: Longint;
var PrefsRec: TPreferenceRec; PrefsFlag: Longint;
begin
  Result:=-1;
  FillChar(PrefsRec, SizeOf(TPreferenceRec), 0);
  try
    if Assigned(FOnSetPreferences) then FOnSetPreferences(FPrefStrings);
    if SetPrefs(PrefsRec) then begin
      PrefsFlag:=GetFlags;
      if PrefsFlag<>0 then begin
	Result:=SetPreferences(PrefsRec, PrefsFlag);
	if Result<0 then
	  ShowError(FOnFailure, Result, EMPTY)
	else if (FPGPPrefs<>[PGPPref_DefaultKeyID]) and Assigned(FGetKeyProps) then FGetKeyProps.Update;
      end;
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownPrefsErr);
  end;
end;

// TPGPKeysGenerate ------------------------------------------------------------

constructor TKeyGenerator.Create(AOwner: TComponent);
begin
  inherited Create(true);
  FreeOnTerminate:=true;
  GeneratingKeys:=true;
  FOwner:=AOwner;
end;

destructor TKeyGenerator.Destroy;
begin
  GeneratingKeys:=false;
  inherited Destroy;
end;

procedure TKeyGenerator.Execute;
begin
  FOnExecute(Self);
end;

constructor TPGPKeysGenerate.Create;
begin
  inherited Create(AOwner);
  FastGenerate:=true;
  MinPassLen:=10;
  MinPassQual:=100;
  Enabled:=false;
end;

destructor TPGPKeysGenerate.Destroy;
begin
  inherited Destroy;
end;

function TPGPKeysGenerate.GetUserID: String;
begin
  if FEmailAddress<>EMPTY then begin
    Result:=LT + FEmailAddress + GT;
    if FUserName<>EMPTY then Result:=FUserName + SPACE + Result;
  end
  else Result:=FUserName;
end;

function TPGPKeysGenerate.GetKeySize: Longint;
begin
  Result:=0;
  case FKeySize of
    PGPKeySize_512: Result:=512;
    PGPKeySize_1024: Result:=1024;
    PGPKeySize_2048: Result:=2048;
  end;
end;

function TPGPKeysGenerate.GetSubKeySize: Longint;
begin
  Result:=0;
  case FSubKeySize of
    PGPSubKeySize_512: Result:=512;
    PGPSubKeySize_1024: Result:=1024;
    PGPSubKeySize_2048: Result:=2048;
    PGPSubKeySize_4096: Result:=4096;
  end;
end;

procedure TPGPKeysGenerate.SetUserName(const Name: String);
begin
  if Name<>FUserName then begin
    if pos(AT, Name)=0 then
      FUserName:=Trim(Name)
    else MessageBox(0, PChar(IllegalUserName + Name), PChar(Self.Name), MB_ICONERROR);
  end;
end;

procedure TPGPKeysGenerate.SetEmailAddress(const Address: String);
begin
  if Address<>FEmailAddress then begin
    if (Address=EMPTY) or (pos(AT, Address)<>0) then
      FEmailAddress:=Trim(Address)
    else MessageBox(0, PChar(IllegalEmailAddress + Address), PChar(Self.Name), MB_ICONERROR);
  end;
end;

function TPGPKeysGenerate.GetPassphrase: Boolean;
var iResult: Longint;
begin
  Result:=false;
  if fStandardDlg then begin
    if FKeyAlg=PGPPublicKeyAlgorithm_ElGamal then
      iResult:=UIKeyPassphraseDialog(FMasterKeyHexID, FPassphrase, ParentHandle)
    else iResult:=UIConfirmationPassphraseDialog(FPassphrase, true, FMinPassQual, FMinPassLen, ParentHandle);
    if iResult=0 then
      Result:=true
    else if iResult<>kPGPError_UserAbort then ShowError(FOnFailure, iResult, EMPTY);
  end
  else begin
    if Assigned(FOnGetGenPassphrase) then FOnGetGenPassphrase(FMinPassLen, FMinPassQual, FPassphrase);
    if FPassphrase<>EMPTY then begin
      if fKeyAlg<>PGPPublicKeyAlgorithm_ElGamal then begin
	iResult:=EstimatePassphraseQuality(FPassPhrase);
	if Length(FPassPhrase)<ord(FMinPassLen) then
	  ShowError(FOnFailure, ord(FMinPassLen), LowPassLenErr)
	else if iResult>0 then begin
	  if iResult<ord(FMinPassQual) then
	    ShowError(FOnFailure, ord(FMinPassQual), LowPassQualErr)
	  else Result:=true;
	end;
      end
      else Result:=true;
    end;
  end;
  Application.ProcessMessages;
end;

procedure TPGPKeysGenerate.OnKeyPairExecute(Sender: TObject);
begin
  try
    Enabled:=true;
    FMasterKeyOnly:=false;
    if Assigned(OnTimer) then OnTimer(Self);
    FGenResult:=KeyGenerate(FUser, FPassphrase, FNewKeyHexID,
			    ord(PGPPublicKeyAlgorithm_DSA), ord(FCipherAlg), GetKeySize,
			    FExpires, FFastGenerate, FFailNoEntropy, FParentHandle);
    if FGenResult=0 then begin
      FMasterKeyOnly:=true;
      FGenResult:=SubKeyGenerate(FNewKeyHexID, FPassphrase, FNewSubKeyHexID,
				 ord(PGPPublicKeyAlgorithm_ElGamal), GetSubKeySize,
				 FExpires, FFastGenerate, FFailNoEntropy, FParentHandle);
      if FGenResult=0 then FMasterKeyOnly:=false;
    end;
  except
    FGenResult:=-1;
  end;
  WipePassphrase(FPassphrase, FOnWipePassphrase);
end;

procedure TPGPKeysGenerate.OnKeyPairTerminate(Sender: TObject);
begin
  Enabled:=false;
  try
    try
      if (FGenResult<>0) and (FGenResult<>kPGPError_UserAbort) then ShowError(FOnFailure, FGenResult, EMPTY);
    finally
      if Assigned(FOnTermination) then FOnTermination(FUser, FNewKeyHexID, FMasterKeyOnly, FGenResult<>0);
      if (FMasterKeyOnly or (FGenResult=0)) and Assigned(FGetKeyProps) then FGetKeyProps.Update;
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, UnknownKeyGenErr + ' or ' + UnknownSubKeyGenErr);
  end;
end;

function TPGPKeysGenerate.DHDSSKeyGenerate: Longint;
begin
  Result:=-1;
  if not GeneratingKeys then begin
    try
      if Assigned(FOnGetUserNameAddress) then FOnGetUserNameAddress(FUserName, FEmailAddress);
      if ((FUserName + FEmailAddress)<>EMPTY) and GetPassphrase then begin
	if FKeySize>PGPKeySize_1024 then FKeySize:=PGPKeySize_1024;
	FUser:=GetUserID;
	FKeyGenerator:=TKeyGenerator.Create(Self);
	if Assigned(FKeyGenerator) then with FKeyGenerator do begin
	  OnTerminate:=OnKeyPairTerminate;
	  FOnExecute:=OnKeyPairExecute;
	  FKeyGenerator.Resume;
	  Result:=0;
	end
	else ShowError(FOnFailure, -1, UnknownKeyGenErr + ' or ' + UnknownSubKeyGenErr);
      end;
    except
      on EFailException do Raise;
      else ShowError(FOnFailure, -1, UnknownKeyGenErr + ' or ' + UnknownSubKeyGenErr);
    end;
  end;
end;

procedure TPGPKeysGenerate.OnSingleKeyTerminate(Sender: TObject);
var sErrorMsg, sHexKeyID: String;
begin
  Enabled:=false;
  try
    if FKeyAlg=PGPPublicKeyAlgorithm_ElGamal then begin
      sErrorMsg:=UnknownSubKeyGenErr;
      sHexKeyID:=FMasterKeyHexID;
    end
    else begin
      sErrorMsg:=UnknownKeyGenErr;
      sHexKeyID:=FNewKeyHexID;
    end;
    try
      if FGenResult<>kPGPError_UserAbort then ShowError(FOnFailure, FGenResult, EMPTY);
    finally
      if Assigned(FOnTermination) then FOnTermination(FUser, sHexKeyID, FMasterKeyOnly, FGenResult<>0);
      if (FGenResult=0) and Assigned(FGetKeyProps) then FGetKeyProps.Update;
    end;
  except
    on EFailException do Raise;
    else ShowError(FOnFailure, -1, sErrorMsg);
  end;
end;

procedure TPGPKeysGenerate.OnSingleKeyExecute(Sender: TObject);
begin
  try
    Enabled:=true;
    FMasterKeyOnly:=false;
    if Assigned(OnTimer) then OnTimer(Self);
    if fKeyAlg=PGPPublicKeyAlgorithm_ElGamal then begin
      FGenResult:=SubKeyGenerate(FMasterKeyHexID, FPassphrase, FNewSubKeyHexID, ord(fKeyAlg),
				 FSize, FExpires, FFastGenerate, FFailNoEntropy, FParentHandle);
    end
    else begin
      FGenResult:=KeyGenerate(FUser, FPassphrase, FNewKeyHexID, ord(FKeyAlg), ord(FCipherAlg),
			      FSize, FExpires, FFastGenerate, FFailNoEntropy, FParentHandle);
    end;
  except
    FGenResult:=-1;
  end;
  WipePassphrase(FPassphrase, FOnWipePassphrase);
end;

function TPGPKeysGenerate.DHSubKeyGenerate: Longint;
var
  KeyPropsLen: Longint;
  KeyPropsStr: String;
  KeyProps: TKeyProps;
  rKeyProps: TKeyRec;
begin
  Result:=-1;
  if not GeneratingKeys then begin
    try
      if Assigned(FOnGetMasterKeyHexID) then FOnGetMasterKeyHexID(FMasterKeyHexID);
      if not ShowHexError(FOnFailure, Self.Name, FMasterKeyHexID) then begin
	if KeyIsOnRing(FMasterKeyHexID) then begin
	  KeyPropsLen:=512;
	  KeyProps:=[PGPKeyProp_UserID, PGPKeyProp_Algorithm, PGPKeyProp_Secret];
	  KeyPropsStr:=IntToStr(GetKeyPropsFlag(KeyProps));
	  Result:=SPGP.KeyProps(FMasterKeyHexID, KeyPropsStr, KeyPropsLen);
	  if Result=0 then begin
	    rKeyProps:=ExtractKeyProps(KeyPropsStr, KeyProps);
	    if (rKeyProps.kType=PGPPrivate) and (rKeyProps.kAlgorithm=PGPPublicKeyAlgorithm_DSA) then begin
	      FKeyAlg:=PGPPublicKeyAlgorithm_ElGamal;
	      if GetPassphrase then begin
		FSize:=GetSubKeySize;
		FUser:=rKeyProps.kUserID;
		FKeyGenerator:=TKeyGenerator.Create(Self);
		if Assigned(FKeyGenerator) then with FKeyGenerator do begin
		  OnTerminate:=OnSingleKeyTerminate;
		  FOnExecute:=OnSingleKeyExecute;
		  FKeyGenerator.Resume;
		  Result:=0;
		end
		else ShowError(FOnFailure, -1, UnknownKeyGenErr);
	      end;
	    end
	    else ShowError(FOnFailure, -1, InvalidMasterKey + FMasterKeyHexID);
	  end
	  else ShowError(FOnFailure, Result, EMPTY);
	end
	else ShowError(FOnFailure, -1, InvalidMasterKey + FMasterKeyHexID);
      end;
    except
      on EFailException do Raise;
      else ShowError(FOnFailure, -1, UnknownSubKeyGenErr);
    end;
  end;
end;

function TPGPKeysGenerate.DSAKeyGenerate: Longint;
begin
  Result:=-1;
  if not GeneratingKeys then begin
    try
      if Assigned(FOnGetUserNameAddress) then FOnGetUserNameAddress(FUserName, FEmailAddress);
      if ((FUserName + FEmailAddress)<>EMPTY) and GetPassphrase then begin
	if FKeySize>PGPKeySize_1024 then FKeySize:=PGPKeySize_1024;
	FKeyAlg:=PGPPublicKeyAlgorithm_DSA;
	FSize:=GetKeySize;
	FUser:=GetUserID;
	FKeyGenerator:=TKeyGenerator.Create(Self);
	if Assigned(FKeyGenerator) then with FKeyGenerator do begin
	  OnTerminate:=OnSingleKeyTerminate;
	  FOnExecute:=OnSingleKeyExecute;
	  FKeyGenerator.Resume;
	  Result:=0;
	end
	else ShowError(FOnFailure, -1, UnknownKeyGenErr);
      end;
    except
      on EFailException do Raise;
      else ShowError(FOnFailure, -1, UnknownKeyGenErr);
    end;
  end;
end;

function TPGPKeysGenerate.RSAKeyGenerate: Longint;
begin
  Result:=-1;
  if not GeneratingKeys then begin
    try
      if Assigned(FOnGetUserNameAddress) then FOnGetUserNameAddress(FUserName, FEmailAddress);
      if ((FUserName + FEmailAddress)<>EMPTY) and GetPassphrase then begin
	FKeyAlg:=PGPPublicKeyAlgorithm_RSA;
	FSize:=GetKeySize;
	FUser:=GetUserID;
	FKeyGenerator:=TKeyGenerator.Create(Self);
	if Assigned(FKeyGenerator) then with FKeyGenerator do begin
	  OnTerminate:=OnSingleKeyTerminate;
	  FOnExecute:=OnSingleKeyExecute;
	  FKeyGenerator.Resume;
	  Result:=0;
	end
	else ShowError(FOnFailure, -1, UnknownKeyGenErr);
      end;
    except
      on EFailException do Raise;
      else ShowError(FOnFailure, -1, UnknownKeyGenErr);
    end;
  end;
end;

procedure Register;
begin
  RegisterComponents('PGP', [TPGPGetKeyProps, TPGPSetKeyProps,
			     TPGPKeySign, TPGPKeySigRemove,
			     TPGPKeyImport, TPGPKeyExport,
			     TPGPDetachedSigCreate, TPGPDetachedSigVerify,
			     TPGPEncode, TPGPDecode,
			     TPGPPreferences, TPGPAnalyze,
			     TPGPKeysGenerate]);
end;

end.

